/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 1)
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern16 (x3, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern16 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern16 (x3, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  return pattern41 (x3); /* [-1, 0] */
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern53 (x1, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern53 (x1, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern53 (x1, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern53 (x1, 
E_TImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern61 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern61 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  return 0;
}

int
pattern81 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  return pattern62 (x1); /* [-1, 1] */
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x8;
      return 0;

    case ROTATE:
      if (GET_MODE (x8) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode)
          || !contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      return 1;

    case LSHIFTRT:
      res = pattern92 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case ASHIFT:
      res = pattern92 (x5);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern117 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1)
      || !setmem_operand (operands[2], i3)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1, machine_mode i1, int i2, rtx_code i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i4
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LABEL_REF)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  return pattern170 (); /* [-1, 1] */
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      return 0;

    case SUBREG:
    case MEM:
      operands[1] = x2;
      if (!s_operand (operands[1], E_QImode))
        return -1;
      res = pattern71 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SCRATCH)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case SUBREG:
        case MEM:
          operands[3] = x7;
          if (!memory_operand (operands[3], E_VOIDmode))
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SCRATCH)
            return -1;
          return 1;

        case CONST:
          if (GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 17
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          x5 = XEXP (x4, 0);
          switch (GET_CODE (x5))
            {
            case SCRATCH:
              return 2;

            case REG:
            case SUBREG:
              operands[3] = x5;
              if (!register_operand (operands[3], E_VOIDmode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern250 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (SUBREG_BYTE (x7))
    {
    case 0:
      if (maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          return pattern257 (x2, 
E_TImode, 
E_DImode); /* [-1, 0] */

        case E_DImode:
          if (pattern257 (x2, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x7) != E_SImode
          || maybe_ne (SUBREG_BYTE (x4), 4)
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode)
          || !register_operand (operands[3], E_TImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern284 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !addv_const_operand (operands[2], i2)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 926; /* popcountv16qi2_vxe */
      if (!
#line 1346 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
        return -1;
      return 930; /* popcountv16qi2_vx */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 927; /* popcountv8hi2_vxe */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 928; /* popcountv4si2_vxe */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 929; /* popcountv2di2_vxe */

    case E_DImode:
      if (pattern104 (x2, pnum_clobbers, 
E_DImode) != 0
          || !(
#line 12113 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 792 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 2637; /* *popcountdi_z196 */

    case E_SImode:
      if (pattern104 (x2, pnum_clobbers, 
E_SImode) != 0
          || !
#line 12113 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2638; /* *popcountsi_z196 */

    case E_HImode:
      if (pattern104 (x2, pnum_clobbers, 
E_HImode) != 0
          || !
#line 12113 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2639; /* *popcounthi_z196 */

    case E_QImode:
      if (pattern104 (x2, pnum_clobbers, 
E_QImode) != 0
          || !
#line 12113 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2640; /* *popcountqi_z196 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1171; /* vec_widen_smult_even_v1qi */

    case 1:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1172; /* vec_widen_smult_even_v2qi */

    case 2:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1173; /* vec_widen_smult_even_v4qi */

    case 3:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1174; /* vec_widen_smult_even_v8qi */

    case 4:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1175; /* vec_widen_smult_even_v16qi */

    case 5:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1176; /* vec_widen_smult_even_v1hi */

    case 6:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1177; /* vec_widen_smult_even_v2hi */

    case 7:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1178; /* vec_widen_smult_even_v4hi */

    case 8:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1179; /* vec_widen_smult_even_v8hi */

    case 9:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1180; /* vec_widen_smult_even_v1si */

    case 10:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1181; /* vec_widen_smult_even_v2si */

    case 11:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1182; /* vec_widen_smult_even_v4si */

    case 12:
      if (!
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1183; /* vec_widen_smult_even_v1di */

    case 13:
      if (!(
#line 1717 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1184; /* vec_widen_smult_even_v2di */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case AND:
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != NOT)
                return -1;
              operands[3] = x5;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern221 (x2, 
E_V16QImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 46; /* vselv16qi */

                case E_V8HImode:
                  if (pattern221 (x2, 
E_V8HImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 47; /* vselv8hi */

                case E_V4SImode:
                  if (pattern221 (x2, 
E_V4SImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 48; /* vselv4si */

                case E_V2DImode:
                  if (pattern221 (x2, 
E_V2DImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 49; /* vselv2di */

                case E_V1TImode:
                  if (pattern221 (x2, 
E_V1TImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 50; /* vselv1ti */

                case E_V1DFmode:
                  if (pattern221 (x2, 
E_V1DFmode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 51; /* vselv1df */

                case E_V2DFmode:
                  if (pattern221 (x2, 
E_V2DFmode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 52; /* vselv2df */

                case E_V1SFmode:
                  if (pattern221 (x2, 
E_V1SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 53; /* vselv1sf */

                case E_V2SFmode:
                  if (pattern221 (x2, 
E_V2SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 54; /* vselv2sf */

                case E_V4SFmode:
                  if (pattern221 (x2, 
E_V4SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 81 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 55; /* vselv4sf */

                case E_V1TFmode:
                  if (pattern221 (x2, 
E_V1TFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 81 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 56; /* vselv1tf */

                case E_TFmode:
                  if (pattern221 (x2, 
E_TFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 57; /* vseltf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x6;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V1QImode:
                  if (pattern8 (x2, 
E_V1QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1576; /* *vevalv1qi_iorand */

                case E_V2QImode:
                  if (pattern8 (x2, 
E_V2QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1585; /* *vevalv2qi_iorand */

                case E_V4QImode:
                  if (pattern8 (x2, 
E_V4QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1594; /* *vevalv4qi_iorand */

                case E_V8QImode:
                  if (pattern8 (x2, 
E_V8QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1603; /* *vevalv8qi_iorand */

                case E_V16QImode:
                  if (pattern8 (x2, 
E_V16QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1612; /* *vevalv16qi_iorand */

                case E_V1HImode:
                  if (pattern8 (x2, 
E_V1HImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1621; /* *vevalv1hi_iorand */

                case E_V2HImode:
                  if (pattern8 (x2, 
E_V2HImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1630; /* *vevalv2hi_iorand */

                case E_V4HImode:
                  if (pattern8 (x2, 
E_V4HImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1639; /* *vevalv4hi_iorand */

                case E_V8HImode:
                  if (pattern8 (x2, 
E_V8HImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1648; /* *vevalv8hi_iorand */

                case E_V1SImode:
                  if (pattern8 (x2, 
E_V1SImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1657; /* *vevalv1si_iorand */

                case E_V2SImode:
                  if (pattern8 (x2, 
E_V2SImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1666; /* *vevalv2si_iorand */

                case E_V4SImode:
                  if (pattern8 (x2, 
E_V4SImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1675; /* *vevalv4si_iorand */

                case E_V1DImode:
                  if (pattern8 (x2, 
E_V1DImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1684; /* *vevalv1di_iorand */

                case E_V2DImode:
                  if (pattern8 (x2, 
E_V2DImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1693; /* *vevalv2di_iorand */

                case E_V1TImode:
                  if (pattern8 (x2, 
E_V1TImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1702; /* *vevalv1ti_iorand */

                case E_TImode:
                  if (pattern8 (x2, 
E_TImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1711; /* *vevalti_iorand */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x10 = XEXP (x6, 2);
              operands[5] = x10;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern243 (x2, 
E_DImode) != 0)
                    return -1;
                  if (
#line 4345 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return 1926; /* *risbgn_ior_and_sr_zedi */
                  if (pnum_clobbers == NULL
                      || !
#line 4345 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1927; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern243 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4345 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return 1928; /* *risbgn_ior_and_sr_zesi */
                  if (pnum_clobbers == NULL
                      || !
#line 4345 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1929; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern200 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1954; /* *insvdi_nocc_noshift */
                  if (pnum_clobbers == NULL
                      || !(
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1955; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern200 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return 1956; /* *insvsi_nocc_noshift */
                  if (pnum_clobbers == NULL
                      || !
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1957; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern201 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4549 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1960; /* *insvdi_nocc_appendbitsleft */
                  if (pnum_clobbers == NULL
                      || !(
#line 4549 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1961; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern201 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4549 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return 1962; /* *insvsi_nocc_appendbitsleft */
                  if (pnum_clobbers == NULL
                      || !
#line 4549 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1963; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern202 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4564 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1964; /* *risbgn_di_ior_and_lshiftrt */
                  if (pnum_clobbers == NULL
                      || !(
#line 4564 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1965; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern202 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4564 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return 1966; /* *risbgn_si_ior_and_lshiftrt */
                  if (pnum_clobbers == NULL
                      || !
#line 4564 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1967; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  res = recog_21 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (pnum_clobbers == NULL)
                return -1;
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern189 (x2, 
E_DImode) != 0
                      || !(
#line 4678 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1974; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern189 (x2, 
E_SImode) != 0
                      || !
#line 4678 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1976; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != AND)
        return -1;
      x11 = XEXP (x4, 0);
      operands[3] = x11;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern184 (x2, 
E_V16QImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 58; /* *vselv16qi_swapped */

        case E_V8HImode:
          if (pattern184 (x2, 
E_V8HImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 59; /* *vselv8hi_swapped */

        case E_V4SImode:
          if (pattern184 (x2, 
E_V4SImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 60; /* *vselv4si_swapped */

        case E_V2DImode:
          if (pattern184 (x2, 
E_V2DImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 61; /* *vselv2di_swapped */

        case E_V1TImode:
          if (pattern184 (x2, 
E_V1TImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 62; /* *vselv1ti_swapped */

        case E_V1DFmode:
          if (pattern184 (x2, 
E_V1DFmode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 63; /* *vselv1df_swapped */

        case E_V2DFmode:
          if (pattern184 (x2, 
E_V2DFmode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 64; /* *vselv2df_swapped */

        case E_V1SFmode:
          if (pattern184 (x2, 
E_V1SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 65; /* *vselv1sf_swapped */

        case E_V2SFmode:
          if (pattern184 (x2, 
E_V2SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 80 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 66; /* *vselv2sf_swapped */

        case E_V4SFmode:
          if (pattern184 (x2, 
E_V4SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 81 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 67; /* *vselv4sf_swapped */

        case E_V1TFmode:
          if (pattern184 (x2, 
E_V1TFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 81 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 68; /* *vselv1tf_swapped */

        case E_TFmode:
          if (pattern184 (x2, 
E_TFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 69; /* *vseltf_swapped */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern60 (x2, pnum_clobbers) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode)
          || !
#line 4693 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      *pnum_clobbers = 1;
      return 1978; /* *rosbg_di_rotl */

    case LSHIFTRT:
      switch (pattern63 (x2, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4708 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1980; /* *rosbg_di_srl_bitmask */

        case 1:
          if (!
#line 4708 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 1982; /* *rosbg_si_srl_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern63 (x2, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4728 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1984; /* *rosbg_di_sll_bitmask */

        case 1:
          if (!
#line 4728 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 1986; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (const_int_operand (operands[2], E_VOIDmode))
    {
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 4854 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 780 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2000; /* *insvdi_mem_reg */

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !(
#line 4854 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 780 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
        return -1;
      return 2001; /* *insvsi_mem_reg */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1501; /* extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1503; /* extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1505; /* extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1507; /* extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1509; /* extendv4hiv4si2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2670 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1511; /* vec_unpacks_hi_v16qi */

        case 1:
          if (!
#line 2681 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1512; /* vec_unpacks_lo_v16qi */

        case 2:
          if (!
#line 2719 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1515; /* vec_unpacks_hi_v8hi */

        case 3:
          if (!
#line 2729 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1516; /* vec_unpacks_lo_v8hi */

        case 4:
          if (!
#line 2765 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1519; /* vec_unpacks_hi_v4si */

        case 5:
          if (!
#line 2775 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1520; /* vec_unpacks_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_48 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      operands[1] = x2;
      if (address_operand (operands[1], E_QImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && 
#line 2304 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return 1845; /* *la_64 */
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && 
#line 2531 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && legitimate_la_operand_p (operands[1])))
                return 1849; /* *la_31 */
              break;

            default:
              break;
            }
        }
      break;

    case PC:
      operands[0] = x2;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10375 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2541; /* *indirect_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10394 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2542; /* indirect_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10394 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2543; /* indirect_jump_via_thunksi_z10 */
      if (pnum_clobbers != NULL)
        {
          if (register_operand (operands[0], E_DImode)
              && (
#line 10412 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2544; /* indirect_jump_via_thunkdi */
            }
          if (register_operand (operands[0], E_SImode)
              && (
#line 10412 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2545; /* indirect_jump_via_thunksi */
            }
        }
      if (nonimmediate_operand (operands[0], E_VOIDmode)
          && 
#line 10468 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
        return 2550; /* *indirect2_jump */
      break;

    default:
      break;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case AND:
      return recog_52 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (pnum_clobbers == NULL
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 4
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCUmode)
              || !
#line 4204 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1915; /* *cmpint_sign */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (pattern88 (x2))
            {
            case 0:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 4983 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2008; /* *extendsidi2 */
              if (general_operand (operands[1], E_HImode)
                  && 
#line 5028 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_EXTIMM))
                return 2009; /* *extendhidi2_extimm */
              if (memory_operand (operands[1], E_HImode)
                  && 
#line 5042 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2010; /* *extendhidi2 */
              if (nonimmediate_operand (operands[1], E_QImode)
                  && (
#line 5085 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2013; /* *extendqidi2_extimm */
              if (memory_operand (operands[1], E_QImode)
                  && (
#line 5096 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && TARGET_LONG_DISPLACEMENT) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2015; /* *extendqidi2 */
              if (pnum_clobbers == NULL
                  || !s_operand (operands[1], E_QImode)
                  || !(
#line 5105 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2017; /* *extendqidi2_short_displ */

            case 1:
              if (nonimmediate_operand (operands[1], E_HImode)
                  && 
#line 5054 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2011; /* *extendhisi2_extimm */
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 5069 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM))
                return -1;
              return 2012; /* *extendhisi2 */

            case 2:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && 
#line 5085 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2014; /* *extendqisi2_extimm */
              if (memory_operand (operands[1], E_QImode)
                  && 
#line 5096 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && TARGET_LONG_DISPLACEMENT))
                return 2016; /* *extendqisi2 */
              if (pnum_clobbers == NULL
                  || !s_operand (operands[1], E_QImode)
                  || !
#line 5105 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                return -1;
              *pnum_clobbers = 1;
              return 2018; /* *extendqisi2_short_displ */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern88 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 5141 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2019; /* *zero_extendsidi2 */

            case E_HImode:
              if (nonimmediate_operand (operands[1], E_HImode))
                {
                  if ((
#line 5255 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2024; /* *zero_extendhidi2_z10 */
                  if ((
#line 5270 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2026; /* *zero_extendhidi2_extimm */
                }
              if (!memory_operand (operands[1], E_HImode)
                  || !(
#line 5281 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2030; /* *zero_extendhidi2 */

            case E_QImode:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && (
#line 5270 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2028; /* *zero_extendqidi2_extimm */
              if (!memory_operand (operands[1], E_QImode)
                  || !(
#line 5281 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2032; /* *zero_extendqidi2 */

            default:
              return -1;
            }

        case 1:
          if (nonimmediate_operand (operands[1], E_HImode))
            {
              if (
#line 5255 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return 2025; /* *zero_extendhisi2_z10 */
              if (
#line 5270 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2027; /* *zero_extendhisi2_extimm */
            }
          if (memory_operand (operands[1], E_HImode)
              && 
#line 5281 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2031; /* *zero_extendhisi2 */
          if (pnum_clobbers == NULL
              || !s_operand (operands[1], E_HImode)
              || !
#line 5290 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2034; /* *zero_extendhisi2_31 */

        case 2:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 5270 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return 2029; /* *zero_extendqisi2_extimm */
          if (!memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5281 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2033; /* *zero_extendqisi2 */
          if (!
#line 5302 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2035; /* *zero_extendqisi2_31 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          switch (pattern175 (x2))
            {
            case 0:
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6105 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                {
                  *pnum_clobbers = 1;
                  return 2191; /* *adddi3_sign */
                }
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6391 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              *pnum_clobbers = 1;
              return 2215; /* *adddi3_sign */

            case 1:
              *pnum_clobbers = 1;
              return 2196; /* *addsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode)
              || !
#line 6144 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2194; /* *adddi3_zero */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          switch (pattern158 (x2))
            {
            case 0:
              if (
#line 6156 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                {
                  *pnum_clobbers = 1;
                  return 2195; /* *adddi3_31z */
                }
              if (!
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2197; /* *adddi3 */

            case 1:
              *pnum_clobbers = 1;
              return 2198; /* *addsi3 */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x4, 0);
          operands[3] = x6;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern209 (x2, 
E_DImode) != 0
                  || !
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2290; /* *adddi3_alc */

            case E_SImode:
              if (pattern209 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2291; /* *addsi3_alc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern210 (x2, 
E_DImode) != 0)
                    return -1;
                  if (general_operand (operands[2], E_SImode)
                      && 
#line 6651 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    {
                      *pnum_clobbers = 1;
                      return 2239; /* *subdi3_sign */
                    }
                  if (!memory_operand (operands[2], E_HImode)
                      || !
#line 6877 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2259; /* *subdi3_sign */

                case E_SImode:
                  if (pattern210 (x2, 
E_SImode) != 0
                      || !memory_operand (operands[2], E_HImode))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2244; /* *subsi3_sign */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!general_operand (operands[2], E_SImode)
                  || !
#line 6691 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2242; /* *subdi3_zero */

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern85 (x2, 
E_DImode) != 0)
                    return -1;
                  if (
#line 6703 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    {
                      *pnum_clobbers = 1;
                      return 2243; /* *subdi3_31z */
                    }
                  if (!
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2245; /* *subdi3 */

                case E_SImode:
                  if (pattern85 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 2246; /* *subsi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern211 (x2, 
E_DImode) != 0
                  || !
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2294; /* *subdi3_slb */

            case E_SImode:
              if (pattern211 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2295; /* *subsi3_slb */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              switch (pattern175 (x2))
                {
                case 0:
                  if (general_operand (operands[2], E_SImode)
                      && 
#line 7397 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2307; /* *muldi3_sign */
                  if (!memory_operand (operands[2], E_HImode)
                      || !
#line 7449 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                    return -1;
                  return 2311; /* *muldi3_sign */

                case 1:
                  return 2312; /* *mulsi3_sign */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!nonimmediate_operand (operands[2], E_SImode)
                  || !
#line 7505 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2314; /* mulsidi3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern174 (x2, 
E_DImode) != 0
                  || !
#line 7409 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2308; /* *muldi3 */

            case E_SImode:
              if (pattern174 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2313; /* *mulsi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern113 (x2, 
E_SImode, 
E_DImode) != 0
              || !
#line 779 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2318; /* umulsidi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case EQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1294; /* *vec_cmpeqv1qiv1qi_nocc */
          break;

        case 1:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1297; /* *vec_cmpeqv2qiv2qi_nocc */
          break;

        case 2:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1300; /* *vec_cmpeqv4qiv4qi_nocc */
          break;

        case 3:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1303; /* *vec_cmpeqv8qiv8qi_nocc */
          break;

        case 4:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1306; /* *vec_cmpeqv16qiv16qi_nocc */
          break;

        case 5:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1309; /* *vec_cmpeqv1hiv1hi_nocc */
          break;

        case 6:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1312; /* *vec_cmpeqv2hiv2hi_nocc */
          break;

        case 7:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1315; /* *vec_cmpeqv4hiv4hi_nocc */
          break;

        case 8:
          if (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1318; /* *vec_cmpeqv8hiv8hi_nocc */
          break;

        case 9:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1SImode)
                  && 
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1321; /* *vec_cmpeqv1siv1si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1SFmode)
                  && (
#line 2222 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1348; /* *vec_cmpeqv1sf_quiet_nocc */
            }
          break;

        case 10:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1324; /* *vec_cmpeqv2siv2si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2SFmode)
                  && (
#line 2222 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1349; /* *vec_cmpeqv2sf_quiet_nocc */
            }
          break;

        case 11:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V4SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V4SImode)
                  && 
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1327; /* *vec_cmpeqv4siv4si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V4SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V4SFmode)
                  && (
#line 2222 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1350; /* *vec_cmpeqv4sf_quiet_nocc */
            }
          break;

        case 12:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1330; /* *vec_cmpeqv1div1di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1DFmode)
                  && 
#line 2222 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1351; /* *vec_cmpeqv1df_quiet_nocc */
            }
          break;

        case 13:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2DImode)
                  && 
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1333; /* *vec_cmpeqv2div2di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2DFmode)
                  && 
#line 2222 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1352; /* *vec_cmpeqv2df_quiet_nocc */
            }
          break;

        case 14:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1TImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1TImode)
                  && (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return 1336; /* *vec_cmpeqv1tiv1ti_nocc */
            }
          operands[0] = x3;
          switch (pattern110 (x2))
            {
            case 0:
              if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
                return 1342; /* *vec_cmpeqv1tiv1ti_nocc_emu */
              break;

            case 1:
              if ((
#line 2222 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1353; /* *vec_cmpeqv1tf_quiet_nocc */
              break;

            default:
              break;
            }
          break;

        case 15:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_TImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_TImode)
                  && (
#line 2120 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return 1339; /* *vec_cmpeqtiti_nocc */
            }
          operands[0] = x3;
          switch (pattern111 (x2))
            {
            case 0:
              if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
                return 1343; /* *vec_cmpeqtiti_nocc_emu */
              break;

            case 1:
              if ((
#line 2222 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1354; /* *vec_cmpeqtf_quiet_nocc */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case GT:
      res = recog_35 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GE:
      res = recog_36 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
      res = recog_37 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_54 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 7280 "../../gcc/config/s390/s390.md"
(TARGET_Z13) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2303; /* *cstoreccdi_z13 */

        case 1:
          if (!
#line 7280 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2304; /* *cstoreccsi_z13 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x9))
            {
            case SET:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != MINUS
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x13 = XEXP (x10, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[2])
                  || !
#line 6666 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2240; /* *subdi3_zero_cc */

            case CLOBBER:
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 6679 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2241; /* *subdi3_zero_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              switch (pattern226 (x1))
                {
                case 0:
                  x15 = XEXP (x2, 0);
                  if (GET_MODE (x15) != E_CCL2mode
                      || GET_MODE (x3) != E_CCL2mode)
                    return -1;
                  switch (pattern245 (x1))
                    {
                    case 0:
                      if (!
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2247; /* subdi3_borrow_cc */

                    case 1:
                      return 2248; /* subsi3_borrow_cc */

                    default:
                      return -1;
                    }

                case 1:
                  if (!(
#line 6793 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2249; /* *subdi3_borrow_cconly */

                case 2:
                  if (!
#line 6793 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  return 2250; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern226 (x1))
                    {
                    case 0:
                      switch (pattern245 (x1))
                        {
                        case 0:
                          if ((
#line 6811 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                            return 2251; /* *subdi3_cc */
                          break;

                        case 1:
                          if (
#line 6811 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                            return 2252; /* *subsi3_cc */
                          break;

                        default:
                          break;
                        }
                      break;

                    case 1:
                      if ((
#line 6845 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2255; /* *subdi3_cconly */
                      break;

                    case 2:
                      if (
#line 6845 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        return 2256; /* *subsi3_cconly */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x7;
              x9 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x9))
                {
                case SET:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != MINUS)
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  x13 = XEXP (x10, 0);
                  if (!rtx_equal_p (x13, operands[1]))
                    return -1;
                  x11 = XEXP (x10, 1);
                  if (!rtx_equal_p (x11, operands[2]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern276 (x10, 
E_TFmode) != 0
                          || !(
#line 6948 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2268; /* *subtf3_cc */

                    case E_FPRX2mode:
                      if (pattern276 (x10, 
E_FPRX2mode) != 0
                          || !(
#line 6948 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2269; /* *subfprx23_cc */

                    case E_DFmode:
                      if (pattern276 (x10, 
E_DFmode) != 0
                          || !
#line 6948 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2270; /* *subdf3_cc */

                    case E_SFmode:
                      if (pattern276 (x10, 
E_SFmode) != 0
                          || !
#line 6948 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2271; /* *subsf3_cc */

                    case E_TDmode:
                      if (pattern276 (x10, 
E_TDmode) != 0
                          || !(
#line 6948 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2272; /* *subtd3_cc */

                    case E_DDmode:
                      if (pattern276 (x10, 
E_DDmode) != 0
                          || !(
#line 6948 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2273; /* *subdd3_cc */

                    default:
                      return -1;
                    }

                case CLOBBER:
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern256 (
E_TFmode) != 0
                          || !(
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2274; /* *subtf3_cconly */

                    case E_FPRX2mode:
                      if (pattern256 (
E_FPRX2mode) != 0
                          || !(
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2275; /* *subfprx23_cconly */

                    case E_DFmode:
                      if (pattern256 (
E_DFmode) != 0
                          || !
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2276; /* *subdf3_cconly */

                    case E_SFmode:
                      if (pattern256 (
E_SFmode) != 0
                          || !
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2277; /* *subsf3_cconly */

                    case E_TDmode:
                      if (pattern256 (
E_TDmode) != 0
                          || !(
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2278; /* *subtd3_cconly */

                    case E_DDmode:
                      if (pattern256 (
E_DDmode) != 0
                          || !(
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2279; /* *subdd3_cconly */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern144 (x1, 
MINUS))
        {
        case 0:
          if (pattern286 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 6906 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2260; /* *subvdi3_ccoverflow */

        case 1:
          if (pattern286 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 6906 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
            return -1;
          return 2261; /* *subvsi3_ccoverflow */

        default:
          return -1;
        }

    case MINUS:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != MINUS)
        return -1;
      x13 = XEXP (x10, 0);
      if (GET_CODE (x13) != MINUS)
        return -1;
      x16 = XEXP (x5, 0);
      operands[1] = x16;
      x17 = XEXP (x5, 1);
      operands[2] = x17;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XEXP (x13, 1);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x11 = XEXP (x10, 1);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern287 (x1, 
E_DImode) != 0
                  || !(
#line 7138 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2292; /* *subdi3_slb_cc */

            case E_SImode:
              if (pattern287 (x1, 
E_SImode) != 0
                  || !
#line 7138 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2293; /* *subsi3_slb_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x15 = XEXP (x2, 0);
          if (GET_MODE (x15) != E_CCL2mode
              || GET_MODE (x3) != E_CCL2mode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern287 (x1, 
E_DImode) != 0
                  || !
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2296; /* subdi3_slb_borrow1_cc */

            case E_SImode:
              if (pattern287 (x1, 
E_SImode) != 0)
                return -1;
              return 2297; /* subsi3_slb_borrow1_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case BSWAP:
      return recog_104 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_102 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_101 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      switch (pattern36 (x1))
        {
        case 0:
          if (!
#line 1007 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 678; /* *eltswapv16qi */

        case 1:
          if (!
#line 1077 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 680; /* eltswapv4si */

        case 2:
          if (!
#line 1077 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 681; /* eltswapv4sf */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_88 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2142; /* *trunctftd2 */

        case 1:
          if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2143; /* *truncfprx2td2 */

        case 2:
          if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2144; /* *truncdftd2 */

        case 3:
          if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2145; /* *truncsftd2 */

        case 4:
          if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2146; /* *trunctfdd2 */

        case 5:
          if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2147; /* *truncfprx2dd2 */

        case 6:
          if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2148; /* *truncdfdd2 */

        case 7:
          if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2149; /* *truncsfdd2 */

        case 8:
          if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2150; /* *trunctfsd2 */

        case 9:
          if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2151; /* *truncfprx2sd2 */

        case 10:
          if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2152; /* *truncdfsd2 */

        case 11:
          if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2153; /* *truncsfsd2 */

        case 12:
          if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2154; /* *trunctdtf2 */

        case 13:
          if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2158; /* *truncddtf2 */

        case 14:
          if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2162; /* *truncsdtf2 */

        case 15:
          if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2155; /* *trunctdfprx22 */

        case 16:
          if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2159; /* *truncddfprx22 */

        case 17:
          if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2163; /* *truncsdfprx22 */

        case 18:
          if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2156; /* *trunctddf2 */

        case 19:
          if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2160; /* *truncdddf2 */

        case 20:
          if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2164; /* *truncsddf2 */

        case 21:
          if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2157; /* *trunctdsf2 */

        case 22:
          if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2161; /* *truncddsf2 */

        case 23:
          if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2165; /* *truncsdsf2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_91 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s390_unsigned_integer_comparison (x5, E_VOIDmode))
        return -1;
      operands[0] = x5;
      switch (pattern118 (x1))
        {
        case 0:
          if (!(
#line 1665 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1803; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1665 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1804; /* *cmp_and_br_unsigned_si */

        case 2:
          if (!(
#line 1723 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1807; /* *icmp_and_br_unsigned_di */

        case 3:
          if (!
#line 1723 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1808; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_105 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_100 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != 0L)
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 4408 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1946; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4408 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          return 1947; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode
          || pattern90 (x1) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!nonzero_shift_count_operand (operands[4], E_DImode)
          || !
#line 4327 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
        return -1;
      return 1925; /* *extzvdi_clobbercc_lshiftrt */

    case IOR:
      return recog_103 (x1, insn, pnum_clobbers);

    case NE:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x5, 2);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4360 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
            return -1;
          return 1931; /* *extract1bitdi_clobbercc */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCZ1mode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 2302; /* sne */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1948; /* *pre_z10_extvdi */

        case 1:
          return 1949; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case XOR:
      return recog_107 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5514 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2038; /* *fixuns_truncdfdi2_z13 */
            }
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2044; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2040; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2042; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2046; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2048; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2050; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5514 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          *pnum_clobbers = 1;
          return 2039; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2047; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2041; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2043; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2045; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2049; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5529 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2051; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5552 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2052; /* *fix_truncdfdi2_bfp_z13 */
            }
          if (!(
#line 5565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2058; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2054; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2056; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2060; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5599 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2062; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5599 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2063; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5552 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            {
              *pnum_clobbers = 1;
              return 2053; /* *fix_truncsfsi2_bfp_z13 */
            }
          if (!
#line 5565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2061; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2055; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2057; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2059; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2166; /* *extendtftd2 */

        case 1:
          if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2167; /* *extendfprx2td2 */

        case 2:
          if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2168; /* *extenddftd2 */

        case 3:
          if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2169; /* *extendsftd2 */

        case 4:
          if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2170; /* *extendtfdd2 */

        case 5:
          if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2171; /* *extendfprx2dd2 */

        case 6:
          if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2172; /* *extenddfdd2 */

        case 7:
          if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2173; /* *extendsfdd2 */

        case 8:
          if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2174; /* *extendtfsd2 */

        case 9:
          if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2175; /* *extendfprx2sd2 */

        case 10:
          if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2176; /* *extenddfsd2 */

        case 11:
          if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2177; /* *extendsfsd2 */

        case 12:
          if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2178; /* *extendtdtf2 */

        case 13:
          if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2182; /* *extendddtf2 */

        case 14:
          if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2186; /* *extendsdtf2 */

        case 15:
          if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2179; /* *extendtdfprx22 */

        case 16:
          if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2183; /* *extendddfprx22 */

        case 17:
          if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2187; /* *extendsdfprx22 */

        case 18:
          if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2180; /* *extendtddf2 */

        case 19:
          if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2184; /* *extenddddf2 */

        case 20:
          if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2188; /* *extendsddf2 */

        case 21:
          if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2181; /* *extendtdsf2 */

        case 22:
          if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2185; /* *extendddsf2 */

        case 23:
          if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2189; /* *extendsdsf2 */

        default:
          return -1;
        }

    case NOT:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (pattern193 (x3))
            {
            case 0:
              if (!(
#line 8654 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2397; /* *notdi */

            case 1:
              if (!
#line 8654 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2398; /* *notsi */

            default:
              return -1;
            }

        case XOR:
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          x10 = XEXP (x5, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern227 (x3, 
E_DImode) != 0
                  || !(
#line 9059 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2414; /* *nxordi */

            case E_SImode:
              if (pattern227 (x3, 
E_SImode) != 0
                  || !
#line 9059 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2415; /* *nxorsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_106 (x1, insn, pnum_clobbers);

    case ABS:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern178 (x3) != 0
              || !
#line 9297 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2444; /* *absdi2_sign */

        case REG:
        case SUBREG:
          switch (pattern179 (x3))
            {
            case 0:
              if (!
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2449; /* absdi2 */

            case 1:
              return 2450; /* abssi2 */

            case 2:
              if (!(
#line 9385 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2465; /* *abstf2 */

            case 3:
              if (!(
#line 9385 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2466; /* *absfprx22 */

            case 4:
              if (!
#line 9385 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2467; /* *absdf2 */

            case 5:
              if (!
#line 9385 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2468; /* *abssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern39 (x13) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (pattern193 (x3))
        {
        case 0:
          if (
#line 9727 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2510; /* *ashrdi3_31 */
          if (!
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2513; /* *ashrdi3 */

        case 1:
          return 2516; /* *ashrsi3 */

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x14 = XEXP (x13, 0);
      operands[3] = x14;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      if (bras_sym_operand (operands[1], E_VOIDmode))
        {
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 10968 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
            return 2574; /* *bras_r */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 10981 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
            return 2575; /* *brasl_r */
        }
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (address_operand (operands[1], E_VOIDmode)
          && 
#line 10995 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2576; /* *basr_r */
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 11019 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2577; /* *basr_r_via_thunk_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if ((
#line 11042 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2578; /* *basr_r_via_thunk */
        }
      if (!(
#line 11042 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2579; /* *basr_r_via_thunk */

    case POPCOUNT:
      if (pattern40 (x1) != 0
          || !
#line 12103 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 2636; /* *popcountdi_z15 */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 16
          || GET_MODE (x3) != E_CCRAWmode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x15 = XEXP (x13, 1);
      if (pattern152 (x15, 
E_BLKmode, 
17, 
UNSPEC_VOLATILE, 
1) != 0)
        return -1;
      x16 = XVECEXP (x3, 0, 0);
      operands[0] = x16;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x17 = XVECEXP (x15, 0, 0);
      if (!rtx_equal_p (x17, operands[0]))
        return -1;
      if (pnum_clobbers != NULL)
        {
          if (
#line 12377 "../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 32;
              return 2648; /* tbegin_1_z13 */
            }
          if (
#line 12405 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 16;
              return 2649; /* tbegin_1 */
            }
        }
      if (!
#line 12416 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2650; /* tbegin_nofloat_1 */

    default:
      return -1;
    }
}
