/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 16
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 17
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 16
      || GET_MODE (x8) != i2)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != i4
      || GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != i3
      || GET_MODE (x12) != i2)
    return -1;
  x13 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != i1)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern19 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern19 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern19 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern19 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern19 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern19 (x3, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          if (!register_operand (operands[1], E_V1QImode)
              || !register_operand (operands[2], E_V1QImode))
            return -1;
          return 0;

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode)
              || !register_operand (operands[2], E_V2QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (pattern16 (x3, 
E_V4QImode, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern16 (x3, 
E_V8QImode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern16 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          if (!register_operand (operands[1], E_V1HImode)
              || !register_operand (operands[2], E_V1HImode))
            return -1;
          return 5;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !register_operand (operands[2], E_V2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern16 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern16 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          if (!register_operand (operands[1], E_V1SImode)
              || !register_operand (operands[2], E_V1SImode))
            return -1;
          return 9;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern16 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 11;

    case E_V1TImode:
      if (pattern16 (x3, 
E_V1DImode, 
E_V1TImode) != 0)
        return -1;
      return 12;

    case E_TImode:
      if (pattern16 (x3, 
E_V2DImode, 
E_TImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern19 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern19 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern19 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern19 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern19 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern19 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern19 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern19 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V1TFmode:
      if (pattern19 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern19 (x1, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCUmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCUmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          return 1;

        case E_QImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern97 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  switch (GET_CODE (x3))
    {
    case MEM:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 32)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_BLKmode)
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 0
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 0);
      operands[3] = x13;
      x14 = XEXP (x4, 0);
      operands[0] = x14;
      x15 = XEXP (x6, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x7, 0);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          return pattern123 (x5, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern123 (x5, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 6)
        return -1;
      x17 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x18 = XEXP (x12, 0);
      operands[3] = x18;
      x14 = XEXP (x4, 0);
      operands[1] = x14;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      x20 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x20))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
        case PLUS:
          operands[2] = x20;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern124 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 2;

            case 4:
              if (pattern124 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 3;

            case 12:
              if (pattern124 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 4;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x21 = XEXP (x20, 0);
          operands[2] = x21;
          if (!setmem_operand (operands[2], E_QImode))
            return -1;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern125 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 5;

            case 4:
              if (pattern125 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 6;

            case 12:
              if (pattern125 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern170 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 2;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !immediate_operand (operands[1], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (!s_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !immediate_operand (operands[1], E_SImode))
            return -1;
          return 1;

        case E_HImode:
          if (!s_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !immediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      if (!memory_operand (operands[1], E_VOIDmode)
          || !memory_operand (operands[0], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern215 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern215 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  operands[3] = x1;
  if (!const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !scratch_operand (operands[2], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!bras_sym_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x12 = XEXP (x2, 0);
  switch (GET_MODE (x12))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern292 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern299 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1199; /* vec_widen_smult_odd_v1qi */

    case 1:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1200; /* vec_widen_smult_odd_v2qi */

    case 2:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1201; /* vec_widen_smult_odd_v4qi */

    case 3:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1202; /* vec_widen_smult_odd_v8qi */

    case 4:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1203; /* vec_widen_smult_odd_v16qi */

    case 5:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1204; /* vec_widen_smult_odd_v1hi */

    case 6:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1205; /* vec_widen_smult_odd_v2hi */

    case 7:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1206; /* vec_widen_smult_odd_v4hi */

    case 8:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1207; /* vec_widen_smult_odd_v8hi */

    case 9:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1208; /* vec_widen_smult_odd_v1si */

    case 10:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1209; /* vec_widen_smult_odd_v2si */

    case 11:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1210; /* vec_widen_smult_odd_v4si */

    case 12:
      if (!
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1211; /* vec_widen_smult_odd_v1di */

    case 13:
      if (!(
#line 1737 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1212; /* vec_widen_smult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 396; /* vec_fpintv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 397; /* vec_fpintv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 398; /* vec_fpintv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 399; /* vec_fpintv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 400; /* vec_fpintv2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 401; /* vec_fpintv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 402; /* vec_fpinttf */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_24 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!general_operand (x3, E_DImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              if (
#line 1264 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode) && TARGET_ZARCH))
                return 1757; /* *cmpdi_cct */
              if ((
#line 1352 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1764; /* *cmpdi_ccs */
              if (
#line 1417 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode) && TARGET_ZARCH))
                return 1770; /* *cmpdi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 6862 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2257; /* *subdi3_cconly2 */

        case E_SImode:
          if (!general_operand (x3, E_SImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_SImode))
            {
              if (
#line 1278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode)))
                return 1758; /* *cmpsi_cct */
              if (
#line 1352 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1765; /* *cmpsi_ccs */
              if (
#line 1436 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)))
                return 1771; /* *cmpsi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 6862 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2258; /* *subsi3_cconly2 */

        case E_HImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_HImode)
              || !
#line 1456 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], HImode)))
            return -1;
          return 1772; /* *cmphi_ccu */

        case E_QImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 1472 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], QImode)))
            return -1;
          return 1773; /* *cmpqi_ccu */

        case E_TFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TFmode))
            return -1;
          operands[1] = x3;
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1578 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1787; /* *cmptf_ccs */
          if (register_operand (operands[1], E_TFmode)
              && 
#line 1593 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_VXE))
            return 1793; /* *cmptf_ccs */
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1604 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1794; /* *cmptf_ccsfps */
          if (!register_operand (operands[1], E_TFmode)
              || !
#line 1619 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_VXE))
            return -1;
          return 1800; /* *cmptf_ccsfps */

        case E_FPRX2mode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_FPRX2mode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 1578 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 1788; /* *cmpfprx2_ccs */
          if (!(
#line 1604 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1795; /* *cmpfprx2_ccsfps */

        case E_DFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 1578 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1789; /* *cmpdf_ccs */
          if (!
#line 1604 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1796; /* *cmpdf_ccsfps */

        case E_SFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 1578 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1790; /* *cmpsf_ccs */
          if (!
#line 1604 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1797; /* *cmpsf_ccsfps */

        case E_TDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_TDmode))
            return -1;
          if ((
#line 1578 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1791; /* *cmptd_ccs */
          if (!(
#line 1604 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1798; /* *cmptd_ccsfps */

        case E_DDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DDmode))
            return -1;
          if ((
#line 1578 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1792; /* *cmpdd_ccs */
          if (!(
#line 1604 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1799; /* *cmpdd_ccsfps */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !general_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2211; /* *adddi3_cconly2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !general_operand (operands[2], E_SImode)
              || !
#line 6354 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2212; /* *addsi3_cconly2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_25 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && immediate_operand (operands[1], E_QImode)
                  && immediate_operand (operands[2], E_QImode)
                  && 
#line 1013 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], false))))
                return 1733; /* *tmqi_mem */
              break;

            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && immediate_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && 
#line 1027 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], DImode, HImode, 0) >= 0))
                return 1734; /* *tmdi_reg */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 1043 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], SImode, HImode, 0) >= 0))
                return 1735; /* *tmsi_reg */
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x5;
          switch (pattern155 (x3))
            {
            case 0:
              if (!
#line 7932 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2341; /* *anddi3_cconly */

            case 1:
              if (!
#line 8060 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2352; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x2, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern134 (x3))
            {
            case 0:
              if (!(
#line 8595 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2377; /* *andcdi_cconly */

            case 1:
              if (!
#line 8595 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2379; /* *andcsi_cconly */

            case 2:
              if (!(
#line 8635 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2389; /* *nordi_cconly */

            case 3:
              if (!
#line 8635 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2391; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_DImode)
                  || !
#line 1297 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_ZARCH))
                return -1;
              return 1759; /* *cmpdi_ccs_sign */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 1337 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1762; /* *cmpdi_ccs_signhi_rl */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 1337 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10))
                    return -1;
                  return 1763; /* *cmpdi_ccs_signhi_rl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SImode:
          if (!memory_operand (operands[1], E_HImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 1313 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode)))
            return -1;
          return 1760; /* *cmpsi_ccs_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) == MEM
          && GET_MODE (x4) == E_HImode)
        {
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (larl_operand (operands[1], E_SImode)
                      && 
#line 1375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1766; /* *cmpsi_ccu_zerohi_rlsi */
                  if (larl_operand (operands[1], E_DImode)
                      && 
#line 1388 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1768; /* *cmpsi_ccu_zerohi_rldi */
                }
              break;

            case E_DImode:
              if (larl_operand (operands[1], E_DImode)
                  && register_operand (operands[0], E_DImode)
                  && (
#line 1388 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1767; /* *cmpdi_ccu_zerohi_rldi */
              break;

            default:
              break;
            }
        }
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 1400 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCURmode) && TARGET_ZARCH))
        return -1;
      return 1769; /* *cmpdi_ccu_zero */

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != AND
              || GET_MODE (x5) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x10 = XEXP (x5, 1);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 4533 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 1959; /* *insv_z10_noshift_cconly */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (pattern155 (x3))
            {
            case 0:
              if (!
#line 8346 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2363; /* *iordi3_cconly */

            case 1:
              if (!
#line 8428 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2366; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern134 (x3))
            {
            case 0:
              if (!(
#line 8595 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2378; /* *orcdi_cconly */

            case 1:
              if (!
#line 8595 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2380; /* *orcsi_cconly */

            case 2:
              if (!(
#line 8635 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2390; /* *nanddi_cconly */

            case 3:
              if (!
#line 8635 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2392; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_26 (x1, insn, pnum_clobbers);

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x2, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6679 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2241; /* *subdi3_zero_cconly */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x6, operands[1]))
                return -1;
              switch (pattern188 (x3))
                {
                case 0:
                  if (!(
#line 6793 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2249; /* *subdi3_borrow_cconly */

                case 1:
                  if (!
#line 6793 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2250; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern188 (x3))
                    {
                    case 0:
                      if ((
#line 6845 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pnum_clobbers = 1;
                          return 2255; /* *subdi3_cconly */
                        }
                      break;

                    case 1:
                      if (
#line 6845 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        {
                          *pnum_clobbers = 1;
                          return 2256; /* *subsi3_cconly */
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (x3))
                {
                case E_TFmode:
                  if (!nonimmediate_operand (operands[1], E_TFmode)
                      || !general_operand (operands[2], E_TFmode)
                      || !const0_operand (operands[3], E_TFmode)
                      || !(
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2274; /* *subtf3_cconly */

                case E_FPRX2mode:
                  if (!nonimmediate_operand (operands[1], E_FPRX2mode)
                      || !general_operand (operands[2], E_FPRX2mode)
                      || !const0_operand (operands[3], E_FPRX2mode)
                      || !(
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2275; /* *subfprx23_cconly */

                case E_DFmode:
                  if (!nonimmediate_operand (operands[1], E_DFmode)
                      || !general_operand (operands[2], E_DFmode)
                      || !const0_operand (operands[3], E_DFmode)
                      || !
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2276; /* *subdf3_cconly */

                case E_SFmode:
                  if (!nonimmediate_operand (operands[1], E_SFmode)
                      || !general_operand (operands[2], E_SFmode)
                      || !const0_operand (operands[3], E_SFmode)
                      || !
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2277; /* *subsf3_cconly */

                case E_TDmode:
                  if (!nonimmediate_operand (operands[1], E_TDmode)
                      || !general_operand (operands[2], E_TDmode)
                      || !const0_operand (operands[3], E_TDmode)
                      || !(
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2278; /* *subtd3_cconly */

                case E_DDmode:
                  if (!nonimmediate_operand (operands[1], E_DDmode)
                      || !general_operand (operands[2], E_DDmode)
                      || !const0_operand (operands[3], E_DDmode)
                      || !(
#line 6964 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2279; /* *subdd3_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern155 (x3))
        {
        case 0:
          if (!
#line 8771 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2401; /* *xordi3_cconly */

        case 1:
          if (!
#line 8838 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2404; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !(
#line 9049 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2412; /* *nxordi_cconly */

        case E_SImode:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 9049 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2413; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x3))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 9119 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2420; /* *negdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 9119 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2421; /* *negsi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          switch (pattern135 (x3))
            {
            case 0:
              if (!(
#line 9240 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2429; /* *negtf2_cconly */

            case 1:
              if (!(
#line 9240 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2430; /* *negfprx22_cconly */

            case 2:
              if (!
#line 9240 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2431; /* *negdf2_cconly */

            case 3:
              if (!
#line 9240 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2432; /* *negsf2_cconly */

            default:
              return -1;
            }

        case ABS:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x3))
                {
                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 9467 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2473; /* *negabsdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 9467 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2474; /* *negabssi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_TFmode:
              if (GET_MODE (x4) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !const0_operand (operands[2], E_TFmode)
                  || !(
#line 9504 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2481; /* *negabstf2_cconly */

            case E_FPRX2mode:
              if (GET_MODE (x4) != E_FPRX2mode
                  || !register_operand (operands[1], E_FPRX2mode)
                  || !const0_operand (operands[2], E_FPRX2mode)
                  || !(
#line 9504 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2482; /* *negabsfprx22_cconly */

            case E_DFmode:
              if (GET_MODE (x4) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !const0_operand (operands[2], E_DFmode)
                  || !
#line 9504 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2483; /* *negabsdf2_cconly */

            case E_SFmode:
              if (GET_MODE (x4) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !const0_operand (operands[2], E_SFmode)
                  || !
#line 9504 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2484; /* *negabssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && (
#line 9320 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2447; /* *absdi2_cconly */
                }
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && 
#line 9320 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                {
                  *pnum_clobbers = 1;
                  return 2448; /* *abssi2_cconly */
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      switch (pattern135 (x3))
        {
        case 0:
          if (!(
#line 9365 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2455; /* *abstf2_cconly */

        case 1:
          if (!(
#line 9365 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2456; /* *absfprx22_cconly */

        case 2:
          if (!
#line 9365 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2457; /* *absdf2_cconly */

        case 3:
          if (!
#line 9365 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2458; /* *abssf2_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9727 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2511; /* *ashrdi3_31_cconly */
            }
          if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2514; /* *ashrdi3_cconly */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2517; /* *ashrsi3_cconly */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12095 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
        return -1;
      *pnum_clobbers = 1;
      return 2635; /* *popcountdi_z15_cconly */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 3);
      operands[4] = x4;
      switch (XINT (x2, 1))
        {
        case 61:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!memory_operand (operands[3], E_BLKmode)
              || !const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern19 (x2, 
E_V4SImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 1; /* vec_gather_elementv4si */

            case E_V2DImode:
              if (pattern19 (x2, 
E_V2DImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 2; /* vec_gather_elementv2di */

            case E_V2DFmode:
              if (pattern198 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 3; /* vec_gather_elementv2df */

            case E_V4SFmode:
              if (pattern198 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
                return -1;
              return 4; /* vec_gather_elementv4sf */

            default:
              return -1;
            }

        case 96:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 203; /* verimv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 204; /* verimv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 205; /* verimv4si */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 206; /* verimv2di */

            default:
              return -1;
            }

        case 131:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[3], E_V16QImode)
                  || !
#line 1258 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 357; /* vec_msumv2di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 1269 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 358; /* vmslg */

            default:
              return -1;
            }

        case 118:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 383; /* vstrcv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 384; /* vstrcv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 385; /* vstrcv4si */

            default:
              return -1;
            }

        case 135:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern51 (x2, 
E_V1QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1717; /* vevalv1qi */

            case E_V2QImode:
              if (pattern51 (x2, 
E_V2QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1718; /* vevalv2qi */

            case E_V4QImode:
              if (pattern51 (x2, 
E_V4QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1719; /* vevalv4qi */

            case E_V8QImode:
              if (pattern51 (x2, 
E_V8QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1720; /* vevalv8qi */

            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1721; /* vevalv16qi */

            case E_V1HImode:
              if (pattern51 (x2, 
E_V1HImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1722; /* vevalv1hi */

            case E_V2HImode:
              if (pattern51 (x2, 
E_V2HImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1723; /* vevalv2hi */

            case E_V4HImode:
              if (pattern51 (x2, 
E_V4HImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1724; /* vevalv4hi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1725; /* vevalv8hi */

            case E_V1SImode:
              if (pattern51 (x2, 
E_V1SImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1726; /* vevalv1si */

            case E_V2SImode:
              if (pattern51 (x2, 
E_V2SImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1727; /* vevalv2si */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1728; /* vevalv4si */

            case E_V1DImode:
              if (pattern51 (x2, 
E_V1DImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1729; /* vevalv1di */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1730; /* vevalv2di */

            case E_V1TImode:
              if (pattern51 (x2, 
E_V1TImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1731; /* vevalv1ti */

            case E_TImode:
              if (pattern51 (x2, 
E_TImode) != 0
                  || !
#line 3421 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1732; /* vevalti */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[2] = x5;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!immediate_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern251 (x2, 
E_DImode) != 0
                  || !
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1880; /* *strlendi */

            case E_SImode:
              if (pattern251 (x2, 
E_SImode) != 0
                  || !
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1881; /* *strlensi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_17 (x1, insn, pnum_clobbers);

    case 2:
      return recog_16 (x1, insn, pnum_clobbers);

    case 3:
      return recog_18 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0
          || !
#line 1155 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 722; /* divv4si3 */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0
          || !
#line 1155 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 723; /* divv2di3 */

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0
          || !
#line 1155 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 724; /* divv1ti3 */

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0
          || !
#line 1155 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 725; /* divti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 1901 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1239; /* divv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 1901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1240; /* divv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 1901 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1241; /* divv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1901 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1242; /* divtf3_vr */
      if (!general_operand (operands[2], E_TFmode)
          || !(
#line 7878 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2334; /* divtf3_fpr */

    case E_FPRX2mode:
      if (pattern85 (x3, 
E_FPRX2mode) != 0
          || !(
#line 7878 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2335; /* divfprx23 */

    case E_DFmode:
      if (pattern85 (x3, 
E_DFmode) != 0
          || !
#line 7878 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2336; /* divdf3 */

    case E_SFmode:
      if (pattern85 (x3, 
E_SFmode) != 0
          || !
#line 7878 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2337; /* divsf3 */

    case E_TDmode:
      if (pattern85 (x3, 
E_TDmode) != 0
          || !(
#line 7878 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2338; /* divtd3 */

    case E_DDmode:
      if (pattern85 (x3, 
E_DDmode) != 0
          || !(
#line 7878 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2339; /* divdd3 */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  switch (XINT (x2, 1))
    {
    case 8:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 36)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 36)
        return -1;
      return 2580; /* *set_tp */

    case 7:
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 11747 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2614; /* main_pool */

    case 18:
      if (pattern35 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode)
          || !
#line 12434 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2651; /* *tbeginc_1 */

    case 19:
      if (GET_MODE (x2) != E_CCRAWmode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode
          || !
#line 12451 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2652; /* *tend_1 */

    case 21:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12491 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2655; /* etnd */

    case 22:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12501 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2656; /* ntstg */

    case 25:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12536 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2659; /* efpc */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern213 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == E_CCL1mode)
    {
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) == E_CCL1mode)
        {
          x6 = XEXP (x5, 1);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = XEXP (x5, 0);
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern277 (x1, 
E_DImode) == 0
                      && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2280; /* adddi3_alc_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern277 (x1, 
E_SImode) == 0)
                    return 2281; /* addsi3_alc_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x5, 0);
  switch (GET_MODE (x7))
    {
    case E_DImode:
      if (pattern277 (x1, 
E_DImode) != 0
          || !(
#line 7053 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2284; /* *adddi3_alc_carry2_cc */

    case E_SImode:
      if (pattern277 (x1, 
E_SImode) != 0
          || !
#line 7053 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2285; /* *addsi3_alc_carry2_cc */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      if (pattern148 (x1, 
NEG) != 0
          || !
#line 9087 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
        return -1;
      return 2416; /* *negdi2_sign_cc */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_83 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x6;
      switch (pattern177 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 9229 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2425; /* *negtf2_cc */

        case 1:
          if (!(
#line 9229 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2426; /* *negfprx22_cc */

        case 2:
          if (!
#line 9229 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2427; /* *negdf2_cc */

        case 3:
          if (!
#line 9229 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2428; /* *negsf2_cc */

        case 4:
          if (!(
#line 9240 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2429; /* *negtf2_cconly */

        case 5:
          if (!(
#line 9240 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2430; /* *negfprx22_cconly */

        case 6:
          if (!
#line 9240 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2431; /* *negdf2_cconly */

        case 7:
          if (!
#line 9240 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2432; /* *negsf2_cconly */

        default:
          return -1;
        }

    case ABS:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFTRT:
          if (GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ASHIFT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0)
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x8, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x11 = XEXP (x7, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x13 = XEXP (x12, 1);
          if (pattern253 (x13, 
ABS, 
NEG) != 0)
            return -1;
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != SIGN_EXTEND
              || GET_MODE (x15) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x16 = XEXP (x9, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x12, 0);
          operands[0] = x17;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x15, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !
#line 9434 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2469; /* *negabsdi2_sign_cc */

        case REG:
        case SUBREG:
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern191 (x1, 
ABS, 
NEG))
                {
                case 0:
                  switch (GET_MODE (x4))
                    {
                    case E_DImode:
                      if (pattern261 (x1, 
E_DImode) == 0
                          && (
#line 9456 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2471; /* *negabsdi2_cc */
                      break;

                    case E_SImode:
                      if (pattern261 (x1, 
E_SImode) == 0
                          && 
#line 9456 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                        return 2472; /* *negabssi2_cc */
                      break;

                    default:
                      break;
                    }
                  break;

                case 1:
                  if (GET_MODE (x5) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && scratch_operand (operands[0], E_DImode)
                      && (
#line 9467 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2473; /* *negabsdi2_cconly */
                  break;

                case 2:
                  if (GET_MODE (x5) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && scratch_operand (operands[0], E_SImode)
                      && 
#line 9467 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    return 2474; /* *negabssi2_cconly */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          x12 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x12))
            {
            case SET:
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != NEG)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != ABS)
                return -1;
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern262 (x1, 
E_TFmode) != 0
                      || !(
#line 9493 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2477; /* *negabstf2_cc */

                case E_FPRX2mode:
                  if (pattern262 (x1, 
E_FPRX2mode) != 0
                      || !(
#line 9493 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2478; /* *negabsfprx22_cc */

                case E_DFmode:
                  if (pattern262 (x1, 
E_DFmode) != 0
                      || !
#line 9493 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2479; /* *negabsdf2_cc */

                case E_SFmode:
                  if (pattern262 (x1, 
E_SFmode) != 0
                      || !
#line 9493 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2480; /* *negabssf2_cc */

                default:
                  return -1;
                }

            case CLOBBER:
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern240 (x5, 
E_TFmode) != 0
                      || !(
#line 9504 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2481; /* *negabstf2_cconly */

                case E_FPRX2mode:
                  if (pattern240 (x5, 
E_FPRX2mode) != 0
                      || !(
#line 9504 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2482; /* *negabsfprx22_cconly */

                case E_DFmode:
                  if (pattern240 (x5, 
E_DFmode) != 0
                      || !
#line 9504 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2483; /* *negabsdf2_cconly */

                case E_SFmode:
                  if (pattern240 (x5, 
E_SFmode) != 0
                      || !
#line 9504 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2484; /* *negabssf2_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = recog_95 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case MEM:
      res = recog_96 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_97 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_98 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern38 (x1) == 0)
        {
          switch (GET_CODE (x3))
            {
            case SIGN_EXTEND:
              switch (pattern182 (x3))
                {
                case 0:
                  if (
#line 4204 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1915; /* *cmpint_sign */
                  break;

                case 1:
                  if ((
#line 5105 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2017; /* *extendqidi2_short_displ */
                  break;

                case 2:
                  if (
#line 5105 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                    return 2018; /* *extendqisi2_short_displ */
                  break;

                default:
                  break;
                }
              break;

            case ZERO_EXTEND:
              if (GET_MODE (x3) == E_SImode
                  && register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x3, 0);
                  operands[1] = x4;
                  if (s_operand (operands[1], E_HImode)
                      && 
#line 5290 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return 2034; /* *zero_extendhisi2_31 */
                }
              break;

            default:
              break;
            }
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode))
                {
                  if (s390_alc_comparison (operands[1], E_DImode)
                      && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2298; /* *sconddi */
                  if (s390_slb_comparison (operands[1], E_DImode)
                      && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2300; /* *sconddi_neg */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (s390_alc_comparison (operands[1], E_SImode))
                    return 2299; /* *scondsi */
                  if (s390_slb_comparison (operands[1], E_SImode))
                    return 2301; /* *scondsi_neg */
                }
              break;

            default:
              break;
            }
        }
      break;

    case MULT:
      res = recog_99 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
      if (pnum_clobbers != NULL
          && XWINT (x3, 0) == 0L)
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == USE)
            {
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (memory_operand (operands[0], E_BLKmode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (const_int_operand (operands[1], E_VOIDmode)
                      && 
#line 8998 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
                    {
                      *pnum_clobbers = 1;
                      return 2409; /* *xc_zero */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x3;
      if (!address_operand (operands[1], E_QImode)
          || !
#line 2595 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
        return -1;
      return 1852; /* force_la_31 */

    case PC:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10547 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2551; /* *casesi_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10566 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2552; /* casesi_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10566 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2553; /* casesi_jump_via_thunksi_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if (register_operand (operands[0], E_DImode)
          && (
#line 10584 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2554; /* casesi_jump_via_thunkdi */
        }
      if (!register_operand (operands[0], E_SImode)
          || !(
#line 10584 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2555; /* casesi_jump_via_thunksi */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x3))
        {
        case CLOBBER:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != COMPARE
              || GET_MODE (x5) != E_CCUmode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCUmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern97 (x9, 
E_SImode, 
0, 
USE) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          x13 = XEXP (x7, 0);
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern292 (
E_DImode) != 0
                  || !
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1882; /* *cmpstrdi */

            case E_SImode:
              if (pattern292 (
E_SImode) != 0
                  || !
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1883; /* *cmpstrsi */

            default:
              return -1;
            }

        case SET:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern97 (x9, 
E_CCmode, 
33, 
CLOBBER) != 0)
            return -1;
          switch (pattern126 (x1))
            {
            case 0:
              if (!
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1884; /* *movstr */

            case 1:
              if (!
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1885; /* *movstr */

            case 2:
              if (!(
#line 3951 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1902; /* *setmem_long */

            case 3:
              if (!(
#line 3951 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1903; /* *setmem_long */

            case 4:
              if (!
#line 3979 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1906; /* *setmem_long_31z */

            case 5:
              if (!(
#line 3964 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1904; /* *setmem_long_and */

            case 6:
              if (!(
#line 3964 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1905; /* *setmem_long_and */

            case 7:
              if (!
#line 3991 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
                return -1;
              return 1907; /* *setmem_long_and_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x14 = XEXP (x2, 1);
      switch (GET_CODE (x14))
        {
        case SUBREG:
        case MEM:
          if (pattern74 (x1) != 0)
            return -1;
          switch (pattern194 (x1))
            {
            case 0:
              if (!(
#line 3587 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1886; /* *cpymem_short */

            case 1:
              if (!(
#line 3587 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1887; /* *cpymem_short */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern73 (x1) != 0)
            return -1;
          switch (pattern194 (x1))
            {
            case 0:
              if (!(
#line 4036 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1908; /* *cmpmem_short */

            case 1:
              if (!(
#line 4036 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1909; /* *cmpmem_short */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2142; /* *trunctftd2 */

            case 1:
              if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2143; /* *truncfprx2td2 */

            case 2:
              if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2144; /* *truncdftd2 */

            case 3:
              if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2145; /* *truncsftd2 */

            case 4:
              if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2146; /* *trunctfdd2 */

            case 5:
              if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2147; /* *truncfprx2dd2 */

            case 6:
              if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2148; /* *truncdfdd2 */

            case 7:
              if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2149; /* *truncsfdd2 */

            case 8:
              if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2150; /* *trunctfsd2 */

            case 9:
              if (!(
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2151; /* *truncfprx2sd2 */

            case 10:
              if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2152; /* *truncdfsd2 */

            case 11:
              if (!
#line 5887 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2153; /* *truncsfsd2 */

            case 12:
              if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2154; /* *trunctdtf2 */

            case 13:
              if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2158; /* *truncddtf2 */

            case 14:
              if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2162; /* *truncsdtf2 */

            case 15:
              if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2155; /* *trunctdfprx22 */

            case 16:
              if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2159; /* *truncddfprx22 */

            case 17:
              if (!(
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2163; /* *truncsdfprx22 */

            case 18:
              if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2156; /* *trunctddf2 */

            case 19:
              if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2160; /* *truncdddf2 */

            case 20:
              if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2164; /* *truncsddf2 */

            case 21:
              if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2157; /* *trunctdsf2 */

            case 22:
              if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2161; /* *truncddsf2 */

            case 23:
              if (!
#line 5896 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2165; /* *truncsdsf2 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2166; /* *extendtftd2 */

            case 1:
              if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2167; /* *extendfprx2td2 */

            case 2:
              if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2168; /* *extenddftd2 */

            case 3:
              if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2169; /* *extendsftd2 */

            case 4:
              if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2170; /* *extendtfdd2 */

            case 5:
              if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2171; /* *extendfprx2dd2 */

            case 6:
              if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2172; /* *extenddfdd2 */

            case 7:
              if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2173; /* *extendsfdd2 */

            case 8:
              if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2174; /* *extendtfsd2 */

            case 9:
              if (!(
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2175; /* *extendfprx2sd2 */

            case 10:
              if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2176; /* *extenddfsd2 */

            case 11:
              if (!
#line 5961 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2177; /* *extendsfsd2 */

            case 12:
              if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2178; /* *extendtdtf2 */

            case 13:
              if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2182; /* *extendddtf2 */

            case 14:
              if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2186; /* *extendsdtf2 */

            case 15:
              if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2179; /* *extendtdfprx22 */

            case 16:
              if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2183; /* *extendddfprx22 */

            case 17:
              if (!(
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2187; /* *extendsdfprx22 */

            case 18:
              if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2180; /* *extendtddf2 */

            case 19:
              if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2184; /* *extenddddf2 */

            case 20:
              if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2188; /* *extendsddf2 */

            case 21:
              if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2181; /* *extendtdsf2 */

            case 22:
              if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2185; /* *extendddsf2 */

            case 23:
              if (!
#line 5969 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2189; /* *extendsdsf2 */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 10064 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2535; /* *brxg_64bit */

            case 1:
              if (!
#line 10150 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2537; /* *brx_31bit */

            case 2:
              if (!
#line 10107 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2536; /* *brx_64bit */

            case 3:
              return 2538; /* doloop_si64 */

            case 4:
              if (!
#line 10248 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2539; /* doloop_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern9 (x1))
    {
    case 0:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_147 (insn, operands);

    case 1:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_156 (insn, operands);

    case 2:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_165 (insn, operands);

    case 3:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_174 (insn, operands);

    case 4:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_183 (insn, operands);

    case 5:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_192 (insn, operands);

    case 6:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_201 (insn, operands);

    case 7:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_210 (insn, operands);

    case 8:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_219 (insn, operands);

    case 9:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_228 (insn, operands);

    case 10:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_237 (insn, operands);

    case 11:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_246 (insn, operands);

    case 12:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_255 (insn, operands);

    case 13:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_264 (insn, operands);

    case 14:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_273 (insn, operands);

    case 15:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_282 (insn, operands);

    case 16:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_148 (insn, operands);

    case 17:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_157 (insn, operands);

    case 18:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_166 (insn, operands);

    case 19:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_175 (insn, operands);

    case 20:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_184 (insn, operands);

    case 21:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_193 (insn, operands);

    case 22:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_202 (insn, operands);

    case 23:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_211 (insn, operands);

    case 24:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_220 (insn, operands);

    case 25:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_229 (insn, operands);

    case 26:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_238 (insn, operands);

    case 27:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_247 (insn, operands);

    case 28:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_256 (insn, operands);

    case 29:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_265 (insn, operands);

    case 30:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 31:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_283 (insn, operands);

    case 32:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_149 (insn, operands);

    case 33:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_158 (insn, operands);

    case 34:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_167 (insn, operands);

    case 35:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_176 (insn, operands);

    case 36:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_185 (insn, operands);

    case 37:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_194 (insn, operands);

    case 38:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_203 (insn, operands);

    case 39:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_212 (insn, operands);

    case 40:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_221 (insn, operands);

    case 41:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_230 (insn, operands);

    case 42:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_239 (insn, operands);

    case 43:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_248 (insn, operands);

    case 44:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_257 (insn, operands);

    case 45:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_266 (insn, operands);

    case 46:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_275 (insn, operands);

    case 47:
      if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_284 (insn, operands);

    default:
      return NULL;
    }
}
