/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_count_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      return pattern12 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern12 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern12 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern12 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern12 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern12 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern12 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern12 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern12 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (x2, E_V1SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (x2, E_V2SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (x2, E_V4SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (x2, E_V1DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (x2, E_V2DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      return 13;

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      return 14;

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern30 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern30 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCRAWmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern44 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, int *pnum_clobbers, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 18;

    case E_V1TFmode:
      if (pattern0 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 19;

    case E_V1TImode:
      if (pattern0 (x1, 
E_V1TImode) != 0)
        return -1;
      return 20;

    case E_TImode:
      if (pattern0 (x1, 
E_TImode) != 0)
        return -1;
      return 21;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_DImode) != 0)
        return -1;
      return 22;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_QImode) != 0)
        return -1;
      return 24;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern115 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern115 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern121 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern121 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern121 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern121 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern148 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  return pattern170 (); /* [-1, 1] */
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern242 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const0_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern268 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !general_operand (operands[2], i1)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern293 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (1));
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_BLKmode)
    return -1;
  x11 = XEXP (x9, 0);
  operands[3] = x11;
  x12 = XEXP (x10, 1);
  operands[4] = x12;
  if (!memory_operand (operands[4], E_BLKmode))
    return -1;
  x13 = XVECEXP (x8, 0, 1);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCZmode) != 0
      || !const_int_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !(
#line 3798 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 745 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1893; /* *TDC_insn_tf */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || !(
#line 3798 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 745 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1894; /* *TDC_insn_fprx2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !
#line 3798 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1895; /* *TDC_insn_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !
#line 3798 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1896; /* *TDC_insn_sf */

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || !(
#line 3798 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 746 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1897; /* *TDC_insn_td */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || !(
#line 3798 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 746 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1898; /* *TDC_insn_dd */

    case E_SDmode:
      if (!register_operand (operands[0], E_SDmode)
          || !(
#line 3798 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 747 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1899; /* *TDC_insn_sd */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || pattern35 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !(
#line 1927 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 405; /* *vftciv4sf_cconly */

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 1927 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
        return -1;
      *pnum_clobbers = 1;
      return 406; /* *vftciv2df_cconly */

    case E_V1TFmode:
      if (!register_operand (operands[1], E_V1TFmode)
          || !(
#line 1927 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 407; /* *vftciv1tf_cconly */

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !(
#line 1927 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 408; /* *vftcitf_cconly */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 73:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern19 (x3, 
E_V8HImode) != 0
              || !
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 33; /* vec_zpermv8hi */

        case E_V4SImode:
          if (pattern19 (x3, 
E_V4SImode) != 0
              || !
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 34; /* vec_zpermv4si */

        case E_V4SFmode:
          if (pattern19 (x3, 
E_V4SFmode) != 0
              || !(
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 44 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 35; /* vec_zpermv4sf */

        case E_V2DImode:
          if (pattern19 (x3, 
E_V2DImode) != 0
              || !
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 36; /* vec_zpermv2di */

        case E_V2DFmode:
          if (pattern19 (x3, 
E_V2DFmode) != 0
              || !
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 37; /* vec_zpermv2df */

        case E_V16QImode:
          if (pattern19 (x3, 
E_V16QImode) != 0
              || !
#line 763 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 647; /* vec_permv16qi */

        default:
          return -1;
        }

    case 83:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 677 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 116; /* vacq */

    case 84:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 690 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 117; /* vacccq */

    case 90:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern53 (x3, 
E_V8HImode, 
E_V16QImode) != 0
              || !
#line 870 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 144; /* vec_gfmsum_accumv16qi */

        case E_V4SImode:
          if (pattern53 (x3, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 870 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 145; /* vec_gfmsum_accumv8hi */

        case E_V2DImode:
          if (pattern53 (x3, 
E_V2DImode, 
E_V4SImode) != 0
              || !
#line 870 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 146; /* vec_gfmsum_accumv4si */

        default:
          return -1;
        }

    case 91:
      if (pattern50 (x3, 
E_V2DImode) != 0
          || !
#line 880 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 147; /* vec_gfmsum_accum_128 */

    case 54:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 148; /* vec_vmalv16qi */

        case 1:
          if (!
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 149; /* vec_vmalv8hi */

        case 2:
          if (!
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 150; /* vec_vmalv4si */

        case 3:
          if (!(
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 151; /* vec_vmalv2di */

        case 4:
          if (!(
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 152; /* vec_vmalv1ti */

        case 5:
          if (!(
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 153; /* vec_vmalti */

        default:
          return -1;
        }

    case 55:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 154; /* vec_vmahv16qi */

        case 1:
          if (!
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 155; /* vec_vmahv8hi */

        case 2:
          if (!
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 156; /* vec_vmahv4si */

        case 3:
          if (!(
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 157; /* vec_vmahv2di */

        case 4:
          if (!(
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 158; /* vec_vmahv1ti */

        case 5:
          if (!(
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 159; /* vec_vmahti */

        default:
          return -1;
        }

    case 56:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 160; /* vec_vmalhv16qi */

        case 1:
          if (!
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 161; /* vec_vmalhv8hi */

        case 2:
          if (!
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 162; /* vec_vmalhv4si */

        case 3:
          if (!(
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 163; /* vec_vmalhv2di */

        case 4:
          if (!(
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 164; /* vec_vmalhv1ti */

        case 5:
          if (!(
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 165; /* vec_vmalhti */

        default:
          return -1;
        }

    case 57:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 939 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 166; /* vec_vmaev16qi */

        case 1:
          if (!
#line 939 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 167; /* vec_vmaev8hi */

        case 2:
          if (!
#line 939 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 168; /* vec_vmaev4si */

        case 3:
          if (!(
#line 939 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 169; /* vec_vmaev2di */

        default:
          return -1;
        }

    case 58:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 950 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 170; /* vec_vmalev16qi */

        case 1:
          if (!
#line 950 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 171; /* vec_vmalev8hi */

        case 2:
          if (!
#line 950 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 172; /* vec_vmalev4si */

        case 3:
          if (!(
#line 950 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 173; /* vec_vmalev2di */

        default:
          return -1;
        }

    case 59:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 963 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 174; /* vec_vmaov16qi */

        case 1:
          if (!
#line 963 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 175; /* vec_vmaov8hi */

        case 2:
          if (!
#line 963 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 176; /* vec_vmaov4si */

        case 3:
          if (!(
#line 963 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 177; /* vec_vmaov2di */

        default:
          return -1;
        }

    case 60:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 974 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 178; /* vec_vmalov16qi */

        case 1:
          if (!
#line 974 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 179; /* vec_vmalov8hi */

        case 2:
          if (!
#line 974 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 180; /* vec_vmalov4si */

        case 3:
          if (!(
#line 974 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 181; /* vec_vmalov2di */

        default:
          return -1;
        }

    case 99:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 237; /* vec_sldv16qi */

        case 1:
          if (!
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 238; /* vec_sldv8hi */

        case 2:
          if (!
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 239; /* vec_sldv4si */

        case 3:
          if (!
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 240; /* vec_sldv2di */

        case 4:
          if (!
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 241; /* vec_sldv1ti */

        case 5:
          if (!
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 242; /* vec_sldti */

        case 6:
          if (!
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 243; /* vec_sldv2df */

        case 7:
          if (!(
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 244; /* vec_sldv4sf */

        case 8:
          if (!(
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 245; /* vec_sldv1tf */

        case 9:
          if (!(
#line 1072 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 246; /* vec_sldtf */

        default:
          return -1;
        }

    case 100:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 247; /* vec_sldbv16qi */

        case 1:
          if (!
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 248; /* vec_sldbv8hi */

        case 2:
          if (!
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 249; /* vec_sldbv4si */

        case 3:
          if (!
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 250; /* vec_sldbv2di */

        case 4:
          if (!
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 251; /* vec_sldbv1ti */

        case 5:
          if (!
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 252; /* vec_sldbti */

        case 6:
          if (!
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 253; /* vec_sldbv2df */

        case 7:
          if (!(
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 254; /* vec_sldbv4sf */

        case 8:
          if (!(
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 255; /* vec_sldbv1tf */

        case 9:
          if (!(
#line 1095 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 256; /* vec_sldbtf */

        default:
          return -1;
        }

    case 101:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 257; /* vec_srdbv16qi */

        case 1:
          if (!
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 258; /* vec_srdbv8hi */

        case 2:
          if (!
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 259; /* vec_srdbv4si */

        case 3:
          if (!
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 260; /* vec_srdbv2di */

        case 4:
          if (!
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 261; /* vec_srdbv1ti */

        case 5:
          if (!
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 262; /* vec_srdbti */

        case 6:
          if (!
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 263; /* vec_srdbv2df */

        case 7:
          if (!(
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 264; /* vec_srdbv4sf */

        case 8:
          if (!(
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 265; /* vec_srdbv1tf */

        case 9:
          if (!(
#line 1107 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 266; /* vec_srdbtf */

        default:
          return -1;
        }

    case 107:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 1179 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 343; /* vsbiq */

    case 108:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 1192 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 344; /* vsbcbiq */

    case 110:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x3, 
E_V16QImode) != 0
              || !
#line 1284 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 359; /* vfaev16qi */

        case E_V8HImode:
          if (pattern19 (x3, 
E_V8HImode) != 0
              || !
#line 1284 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 360; /* vfaev8hi */

        case E_V4SImode:
          if (pattern19 (x3, 
E_V4SImode) != 0
              || !
#line 1284 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 361; /* vfaev4si */

        default:
          return -1;
        }

    case 112:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1384 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 365; /* vfeev16qi */

        case 1:
          if (!
#line 1384 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 366; /* vfeev8hi */

        case 2:
          if (!
#line 1384 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 367; /* vfeev4si */

        case 3:
          if (!
#line 1395 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 368; /* vfeezv16qi */

        case 4:
          if (!
#line 1395 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 369; /* vfeezv8hi */

        case 5:
          if (!
#line 1395 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 370; /* vfeezv4si */

        default:
          return -1;
        }

    case 114:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1443 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 371; /* vfenev16qi */

        case 1:
          if (!
#line 1443 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 372; /* vfenev8hi */

        case 2:
          if (!
#line 1443 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 373; /* vfenev4si */

        case 3:
          if (!
#line 1456 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 374; /* vfenezv16qi */

        case 4:
          if (!
#line 1456 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 375; /* vfenezv8hi */

        case 5:
          if (!
#line 1456 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 376; /* vfenezv4si */

        default:
          return -1;
        }

    case 122:
      if (pattern57 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1712 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 392; /* vcdgb */

    case 123:
      if (pattern57 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1744 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 393; /* vcdlgb */

    case 124:
      if (pattern57 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1775 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 394; /* vcgdb */

    case 125:
      if (pattern57 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1808 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 395; /* vclgdb */

    case 126:
      return recog_15 (x1, insn, pnum_clobbers);

    case 128:
      if (pattern57 (x3, 
E_V4SFmode, 
E_V2DFmode) != 0
          || !
#line 1889 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 404; /* vflrd */

    case 132:
      switch (pattern58 (x3))
        {
        case 0:
          if (!
#line 2146 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 473; /* vfminv4sf */

        case 1:
          if (!
#line 2146 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 474; /* vfminv2df */

        case 2:
          if (!
#line 2146 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 475; /* vfminv1tf */

        case 3:
          if (!
#line 2146 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 476; /* vfmintf */

        default:
          return -1;
        }

    case 133:
      switch (pattern58 (x3))
        {
        case 0:
          if (!
#line 2156 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 477; /* vfmaxv4sf */

        case 1:
          if (!
#line 2156 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 478; /* vfmaxv2df */

        case 2:
          if (!
#line 2156 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 479; /* vfmaxv1tf */

        case 3:
          if (!
#line 2156 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 480; /* vfmaxtf */

        default:
          return -1;
        }

    case 92:
      return recog_14 (x1, insn, pnum_clobbers);

    case 140:
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[0], E_V8HImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode)
          || !
#line 2245 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 503; /* vcrnfs_v8hi */

    case 134:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern51 (x3, 
E_V16QImode) != 0
              || !
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 506; /* vblendv16qi */

        case E_V8HImode:
          if (pattern51 (x3, 
E_V8HImode) != 0
              || !
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 507; /* vblendv8hi */

        case E_V4SImode:
          if (pattern51 (x3, 
E_V4SImode) != 0
              || !
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 508; /* vblendv4si */

        case E_V2DImode:
          if (pattern51 (x3, 
E_V2DImode) != 0
              || !
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 509; /* vblendv2di */

        case E_V2DFmode:
          if (pattern153 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 510; /* vblendv2df */

        case E_V1TImode:
          if (pattern51 (x3, 
E_V1TImode) != 0
              || !
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 511; /* vblendv1ti */

        case E_TImode:
          if (pattern51 (x3, 
E_TImode) != 0
              || !
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 512; /* vblendti */

        case E_V4SFmode:
          if (pattern153 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
              || !(
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3) && 
#line 47 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 513; /* vblendv4sf */

        case E_V1TFmode:
          if (pattern153 (x3, 
E_V1TImode, 
E_V1TFmode) != 0
              || !(
#line 2274 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3) && 
#line 47 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 514; /* vblendv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern64 (x3, 
E_V1QImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 700; /* subv1qi3 */

    case E_V2QImode:
      if (pattern64 (x3, 
E_V2QImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 701; /* subv2qi3 */

    case E_V4QImode:
      if (pattern64 (x3, 
E_V4QImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 702; /* subv4qi3 */

    case E_V8QImode:
      if (pattern64 (x3, 
E_V8QImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 703; /* subv8qi3 */

    case E_V16QImode:
      if (pattern64 (x3, 
E_V16QImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 704; /* subv16qi3 */

    case E_V1HImode:
      if (pattern64 (x3, 
E_V1HImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 705; /* subv1hi3 */

    case E_V2HImode:
      if (pattern64 (x3, 
E_V2HImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 706; /* subv2hi3 */

    case E_V4HImode:
      if (pattern64 (x3, 
E_V4HImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 707; /* subv4hi3 */

    case E_V8HImode:
      if (pattern64 (x3, 
E_V8HImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 708; /* subv8hi3 */

    case E_V1SImode:
      if (pattern64 (x3, 
E_V1SImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 709; /* subv1si3 */

    case E_V2SImode:
      if (pattern64 (x3, 
E_V2SImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 710; /* subv2si3 */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V4SImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 711; /* subv4si3 */

    case E_V1DImode:
      if (pattern64 (x3, 
E_V1DImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 712; /* subv1di3 */

    case E_V2DImode:
      if (pattern64 (x3, 
E_V2DImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 713; /* subv2di3 */

    case E_V1TImode:
      if (pattern64 (x3, 
E_V1TImode) != 0
          || !
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 714; /* subv1ti3 */

    case E_TImode:
      if (GET_MODE (x3) != E_TImode
          || !general_operand (operands[2], E_TImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_TImode)
          && nonimmediate_operand (operands[1], E_TImode)
          && 
#line 1137 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 715; /* *subti3 */
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 6612 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2238; /* *subti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 1869 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1231; /* subv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 1869 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1232; /* subv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 1869 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1233; /* subv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1869 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1234; /* subtf3_vr */
      if (pnum_clobbers == NULL
          || !general_operand (operands[2], E_TFmode)
          || !(
#line 6928 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 2262; /* subtf3_fpr */

    case E_FPRX2mode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_FPRX2mode) != 0
          || !(
#line 6928 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 2263; /* subfprx23 */

    case E_DFmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_DFmode) != 0
          || !
#line 6928 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 2264; /* subdf3 */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_SFmode) != 0
          || !
#line 6928 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 2265; /* subsf3 */

    case E_TDmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_TDmode) != 0
          || !(
#line 6928 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 2266; /* subtd3 */

    case E_DDmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_DDmode) != 0
          || !(
#line 6928 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 2267; /* subdd3 */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case PARALLEL:
          switch (XVECLEN (x4, 0))
            {
            case 1:
              x5 = XEXP (x1, 0);
              if (GET_CODE (x5) == MEM)
                {
                  res = recog_19 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[0] = x5;
              operands[1] = x3;
              x6 = XVECEXP (x4, 0, 0);
              operands[2] = x6;
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              switch (pattern154 (x2))
                {
                case 0:
                  if (!nonmemory_operand (operands[1], E_V1QImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 581; /* *vec_extractv1qi */

                case 1:
                  if (!nonmemory_operand (operands[1], E_V2QImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 582; /* *vec_extractv2qi */

                case 2:
                  if (!nonmemory_operand (operands[1], E_V4QImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 583; /* *vec_extractv4qi */

                case 3:
                  if (!nonmemory_operand (operands[1], E_V8QImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 584; /* *vec_extractv8qi */

                case 4:
                  if (!nonmemory_operand (operands[1], E_V16QImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 585; /* *vec_extractv16qi */

                case 5:
                  if (!nonmemory_operand (operands[1], E_V1HImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 586; /* *vec_extractv1hi */

                case 6:
                  if (!nonmemory_operand (operands[1], E_V2HImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 587; /* *vec_extractv2hi */

                case 7:
                  if (!nonmemory_operand (operands[1], E_V4HImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 588; /* *vec_extractv4hi */

                case 8:
                  if (!nonmemory_operand (operands[1], E_V8HImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 589; /* *vec_extractv8hi */

                case 9:
                  if (!nonmemory_operand (operands[1], E_V1SImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 590; /* *vec_extractv1si */

                case 10:
                  if (!nonmemory_operand (operands[1], E_V2SImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 591; /* *vec_extractv2si */

                case 11:
                  if (!nonmemory_operand (operands[1], E_V4SImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 592; /* *vec_extractv4si */

                case 12:
                  if (!nonmemory_operand (operands[1], E_V1DImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 593; /* *vec_extractv1di */

                case 13:
                  if (!nonmemory_operand (operands[1], E_V2DImode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 594; /* *vec_extractv2di */

                case 14:
                  if (!nonmemory_operand (operands[1], E_V1SFmode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 595; /* *vec_extractv1sf */

                case 15:
                  if (!nonmemory_operand (operands[1], E_V2SFmode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 596; /* *vec_extractv2sf */

                case 16:
                  if (!nonmemory_operand (operands[1], E_V4SFmode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 597; /* *vec_extractv4sf */

                case 17:
                  if (!nonmemory_operand (operands[1], E_V1DFmode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 598; /* *vec_extractv1df */

                case 18:
                  if (!nonmemory_operand (operands[1], E_V2DFmode)
                      || !
#line 560 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 599; /* *vec_extractv2df */

                default:
                  return -1;
                }

            case 8:
              if (pattern59 (x4, pnum_clobbers, 
4, 
5, 
6, 
7) != 0)
                return -1;
              x7 = XVECEXP (x4, 0, 4);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return -1;
              x8 = XVECEXP (x4, 0, 5);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return -1;
              x9 = XVECEXP (x4, 0, 6);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x10 = XVECEXP (x4, 0, 7);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              if (!nonimmediate_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode)
                return -1;
              operands[1] = x3;
              if (!nonimmediate_operand (operands[1], E_V8HImode)
                  || !
#line 1038 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 2;
              return 679; /* eltswapv8hi */

            case 4:
              if (pattern59 (x4, pnum_clobbers, 
0, 
1, 
2, 
3) != 0)
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (!nonimmediate_operand (operands[0], E_V4SImode)
                      || GET_MODE (x2) != E_V4SImode
                      || !nonimmediate_operand (operands[1], E_V4SImode)
                      || !
#line 1077 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  *pnum_clobbers = 1;
                  return 680; /* eltswapv4si */

                case E_V4SFmode:
                  if (!nonimmediate_operand (operands[0], E_V4SFmode)
                      || GET_MODE (x2) != E_V4SFmode
                      || !nonimmediate_operand (operands[1], E_V4SFmode)
                      || !
#line 1077 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  *pnum_clobbers = 1;
                  return 681; /* eltswapv4sf */

                default:
                  return -1;
                }

            case 2:
              x6 = XVECEXP (x4, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x11 = XVECEXP (x4, 0, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (!nonimmediate_operand (operands[0], E_V2DImode)
                      || GET_MODE (x2) != E_V2DImode
                      || !nonimmediate_operand (operands[1], E_V2DImode)
                      || !
#line 1107 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 682; /* eltswapv2di */

                case E_V2DFmode:
                  if (!nonimmediate_operand (operands[0], E_V2DFmode)
                      || GET_MODE (x2) != E_V2DFmode
                      || !nonimmediate_operand (operands[1], E_V2DFmode)
                      || !
#line 1107 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 683; /* eltswapv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x12 = XEXP (x4, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 1)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          operands[1] = x3;
          x13 = XEXP (x4, 0);
          operands[2] = x13;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x14 = XVECEXP (x12, 0, 0);
          operands[3] = x14;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern154 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V1QImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 600; /* *vec_extractv1qi_plus */

            case 1:
              if (!register_operand (operands[1], E_V2QImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 601; /* *vec_extractv2qi_plus */

            case 2:
              if (!register_operand (operands[1], E_V4QImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 602; /* *vec_extractv4qi_plus */

            case 3:
              if (!register_operand (operands[1], E_V8QImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 603; /* *vec_extractv8qi_plus */

            case 4:
              if (!register_operand (operands[1], E_V16QImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 604; /* *vec_extractv16qi_plus */

            case 5:
              if (!register_operand (operands[1], E_V1HImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 605; /* *vec_extractv1hi_plus */

            case 6:
              if (!register_operand (operands[1], E_V2HImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 606; /* *vec_extractv2hi_plus */

            case 7:
              if (!register_operand (operands[1], E_V4HImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 607; /* *vec_extractv4hi_plus */

            case 8:
              if (!register_operand (operands[1], E_V8HImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 608; /* *vec_extractv8hi_plus */

            case 9:
              if (!register_operand (operands[1], E_V1SImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 609; /* *vec_extractv1si_plus */

            case 10:
              if (!register_operand (operands[1], E_V2SImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 610; /* *vec_extractv2si_plus */

            case 11:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 611; /* *vec_extractv4si_plus */

            case 12:
              if (!register_operand (operands[1], E_V1DImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 612; /* *vec_extractv1di_plus */

            case 13:
              if (!register_operand (operands[1], E_V2DImode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 613; /* *vec_extractv2di_plus */

            case 14:
              if (!register_operand (operands[1], E_V1SFmode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 614; /* *vec_extractv1sf_plus */

            case 15:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 615; /* *vec_extractv2sf_plus */

            case 16:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 616; /* *vec_extractv4sf_plus */

            case 17:
              if (!register_operand (operands[1], E_V1DFmode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 617; /* *vec_extractv1df_plus */

            case 18:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 577 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 618; /* *vec_extractv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BSWAP:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x15 = XEXP (x3, 0);
      operands[1] = x15;
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern166 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2195 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 491; /* *vec_extract_bswap_vecv8hi */

        case E_SImode:
          if (pattern166 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2195 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 492; /* *vec_extract_bswap_vecv4si */

        case E_SFmode:
          if (pattern166 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2195 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 493; /* *vec_extract_bswap_vecv4sf */

        case E_DImode:
          if (pattern166 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2195 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 494; /* *vec_extract_bswap_vecv2di */

        case E_DFmode:
          if (pattern166 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2195 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 495; /* *vec_extract_bswap_vecv2df */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_20 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern169 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 612 "../../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode)))
            return -1;
          return 621; /* *vec_splatv16qi */

        case E_V8HImode:
          if (pattern169 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 612 "../../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 622; /* *vec_splatv8hi */

        case E_V4SImode:
          if (pattern169 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 612 "../../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 623; /* *vec_splatv4si */

        case E_V4SFmode:
          if (pattern169 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 612 "../../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)))
            return -1;
          return 624; /* *vec_splatv4sf */

        case E_V2DImode:
          if (pattern169 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 612 "../../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 625; /* *vec_splatv2di */

        case E_V2DFmode:
          if (pattern169 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 612 "../../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 626; /* *vec_splatv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !general_operand (operands[1], E_QImode)
              || !
#line 620 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 627; /* *vec_splatsv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 620 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 628; /* *vec_splatsv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !general_operand (operands[1], E_SImode)
              || !
#line 620 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 629; /* *vec_splatsv4si */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !general_operand (operands[1], E_SFmode)
              || !
#line 620 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 630; /* *vec_splatsv4sf */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !general_operand (operands[1], E_DImode)
              || !
#line 620 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 631; /* *vec_splatsv2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !general_operand (operands[1], E_DFmode)
              || !
#line 620 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 632; /* *vec_splatsv2df */

        case E_V1TFmode:
          if (!nonimmediate_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !general_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 653 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return 643; /* *vec_tf_to_v1tf_fpr */
          if (!
#line 666 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 644; /* *vec_tf_to_v1tf_vr */

        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !general_operand (operands[1], E_TImode)
              || !
#line 696 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 646; /* *vec_ti_to_v1ti */

        default:
          return -1;
        }

    case BSWAP:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern84 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 644 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 638; /* *vec_splats_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern84 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 644 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 639; /* *vec_splats_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern84 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 644 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 640; /* *vec_splats_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern84 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 644 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 641; /* *vec_splats_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern84 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 644 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 642; /* *vec_splats_bswap_elemv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern136 (x3, 
E_V4SFmode) != 0
              || !(
#line 1932 "../../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1247; /* fmav4sf4 */

        case E_V2DFmode:
          if (pattern136 (x3, 
E_V2DFmode) != 0
              || !
#line 1932 "../../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V2DFmode)))
            return -1;
          return 1248; /* fmav2df4 */

        case E_V1TFmode:
          if (pattern136 (x3, 
E_V1TFmode) != 0
              || !(
#line 1932 "../../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1249; /* fmav1tf4 */

        case E_TFmode:
          if (pattern136 (x3, 
E_TFmode) != 0
              || !(
#line 1932 "../../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1250; /* fmatf4 */

        case E_DFmode:
          if (pattern137 (x3, 
E_DFmode) != 0
              || !
#line 7591 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (DFmode)))
            return -1;
          return 2325; /* fmadf4 */

        case E_SFmode:
          if (pattern137 (x3, 
E_SFmode) != 0
              || !
#line 7591 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (SFmode)))
            return -1;
          return 2326; /* fmasf4 */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern138 (x3, 
E_V4SFmode) != 0
              || !(
#line 1942 "../../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1251; /* fmsv4sf4 */

        case E_V2DFmode:
          if (pattern138 (x3, 
E_V2DFmode) != 0
              || !
#line 1942 "../../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V2DFmode)))
            return -1;
          return 1252; /* fmsv2df4 */

        case E_V1TFmode:
          if (pattern138 (x3, 
E_V1TFmode) != 0
              || !(
#line 1942 "../../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1253; /* fmsv1tf4 */

        case E_TFmode:
          if (pattern138 (x3, 
E_TFmode) != 0
              || !(
#line 1942 "../../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1254; /* fmstf4 */

        case E_DFmode:
          if (pattern139 (x3, 
E_DFmode) != 0
              || !
#line 7608 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (DFmode)))
            return -1;
          return 2327; /* fmsdf4 */

        case E_SFmode:
          if (pattern139 (x3, 
E_SFmode) != 0
              || !
#line 7608 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (SFmode)))
            return -1;
          return 2328; /* fmssf4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x9))
            {
            case SET:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != MINUS
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x13 = XEXP (x10, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[2])
                  || !
#line 6666 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2240; /* *subdi3_zero_cc */

            case CLOBBER:
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 6679 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2241; /* *subdi3_zero_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              switch (pattern226 (x1))
                {
                case 0:
                  x15 = XEXP (x2, 0);
                  if (GET_MODE (x15) != E_CCL2mode
                      || GET_MODE (x3) != E_CCL2mode)
                    return -1;
                  switch (pattern245 (x1))
                    {
                    case 0:
                      if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2247; /* subdi3_borrow_cc */

                    case 1:
                      return 2248; /* subsi3_borrow_cc */

                    default:
                      return -1;
                    }

                case 1:
                  if (!(
#line 6793 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2249; /* *subdi3_borrow_cconly */

                case 2:
                  if (!
#line 6793 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  return 2250; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern226 (x1))
                    {
                    case 0:
                      switch (pattern245 (x1))
                        {
                        case 0:
                          if ((
#line 6811 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                            return 2251; /* *subdi3_cc */
                          break;

                        case 1:
                          if (
#line 6811 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                            return 2252; /* *subsi3_cc */
                          break;

                        default:
                          break;
                        }
                      break;

                    case 1:
                      if ((
#line 6845 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2255; /* *subdi3_cconly */
                      break;

                    case 2:
                      if (
#line 6845 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        return 2256; /* *subsi3_cconly */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x7;
              x9 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x9))
                {
                case SET:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != MINUS)
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  x13 = XEXP (x10, 0);
                  if (!rtx_equal_p (x13, operands[1]))
                    return -1;
                  x11 = XEXP (x10, 1);
                  if (!rtx_equal_p (x11, operands[2]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern276 (x10, 
E_TFmode) != 0
                          || !(
#line 6948 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2268; /* *subtf3_cc */

                    case E_FPRX2mode:
                      if (pattern276 (x10, 
E_FPRX2mode) != 0
                          || !(
#line 6948 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2269; /* *subfprx23_cc */

                    case E_DFmode:
                      if (pattern276 (x10, 
E_DFmode) != 0
                          || !
#line 6948 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2270; /* *subdf3_cc */

                    case E_SFmode:
                      if (pattern276 (x10, 
E_SFmode) != 0
                          || !
#line 6948 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2271; /* *subsf3_cc */

                    case E_TDmode:
                      if (pattern276 (x10, 
E_TDmode) != 0
                          || !(
#line 6948 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2272; /* *subtd3_cc */

                    case E_DDmode:
                      if (pattern276 (x10, 
E_DDmode) != 0
                          || !(
#line 6948 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2273; /* *subdd3_cc */

                    default:
                      return -1;
                    }

                case CLOBBER:
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern256 (
E_TFmode) != 0
                          || !(
#line 6964 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2274; /* *subtf3_cconly */

                    case E_FPRX2mode:
                      if (pattern256 (
E_FPRX2mode) != 0
                          || !(
#line 6964 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2275; /* *subfprx23_cconly */

                    case E_DFmode:
                      if (pattern256 (
E_DFmode) != 0
                          || !
#line 6964 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2276; /* *subdf3_cconly */

                    case E_SFmode:
                      if (pattern256 (
E_SFmode) != 0
                          || !
#line 6964 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2277; /* *subsf3_cconly */

                    case E_TDmode:
                      if (pattern256 (
E_TDmode) != 0
                          || !(
#line 6964 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2278; /* *subtd3_cconly */

                    case E_DDmode:
                      if (pattern256 (
E_DDmode) != 0
                          || !(
#line 6964 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2279; /* *subdd3_cconly */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern144 (x1, 
MINUS))
        {
        case 0:
          if (pattern286 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 6906 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2260; /* *subvdi3_ccoverflow */

        case 1:
          if (pattern286 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 6906 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
            return -1;
          return 2261; /* *subvsi3_ccoverflow */

        default:
          return -1;
        }

    case MINUS:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != MINUS)
        return -1;
      x13 = XEXP (x10, 0);
      if (GET_CODE (x13) != MINUS)
        return -1;
      x16 = XEXP (x5, 0);
      operands[1] = x16;
      x17 = XEXP (x5, 1);
      operands[2] = x17;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XEXP (x13, 1);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x11 = XEXP (x10, 1);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern287 (x1, 
E_DImode) != 0
                  || !(
#line 7138 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2292; /* *subdi3_slb_cc */

            case E_SImode:
              if (pattern287 (x1, 
E_SImode) != 0
                  || !
#line 7138 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2293; /* *subsi3_slb_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x15 = XEXP (x2, 0);
          if (GET_MODE (x15) != E_CCL2mode
              || GET_MODE (x3) != E_CCL2mode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern287 (x1, 
E_DImode) != 0
                  || !
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2296; /* subdi3_slb_borrow1_cc */

            case E_SImode:
              if (pattern287 (x1, 
E_SImode) != 0)
                return -1;
              return 2297; /* subsi3_slb_borrow1_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case BSWAP:
      return recog_104 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_102 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_101 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      switch (pattern36 (x1))
        {
        case 0:
          if (!
#line 1007 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 678; /* *eltswapv16qi */

        case 1:
          if (!
#line 1077 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 680; /* eltswapv4si */

        case 2:
          if (!
#line 1077 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 681; /* eltswapv4sf */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_88 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2142; /* *trunctftd2 */

        case 1:
          if (!(
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2143; /* *truncfprx2td2 */

        case 2:
          if (!
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2144; /* *truncdftd2 */

        case 3:
          if (!
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2145; /* *truncsftd2 */

        case 4:
          if (!(
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2146; /* *trunctfdd2 */

        case 5:
          if (!(
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2147; /* *truncfprx2dd2 */

        case 6:
          if (!
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2148; /* *truncdfdd2 */

        case 7:
          if (!
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2149; /* *truncsfdd2 */

        case 8:
          if (!(
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2150; /* *trunctfsd2 */

        case 9:
          if (!(
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2151; /* *truncfprx2sd2 */

        case 10:
          if (!
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2152; /* *truncdfsd2 */

        case 11:
          if (!
#line 5887 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2153; /* *truncsfsd2 */

        case 12:
          if (!(
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2154; /* *trunctdtf2 */

        case 13:
          if (!(
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2158; /* *truncddtf2 */

        case 14:
          if (!(
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2162; /* *truncsdtf2 */

        case 15:
          if (!(
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2155; /* *trunctdfprx22 */

        case 16:
          if (!(
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2159; /* *truncddfprx22 */

        case 17:
          if (!(
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2163; /* *truncsdfprx22 */

        case 18:
          if (!
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2156; /* *trunctddf2 */

        case 19:
          if (!
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2160; /* *truncdddf2 */

        case 20:
          if (!
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2164; /* *truncsddf2 */

        case 21:
          if (!
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2157; /* *trunctdsf2 */

        case 22:
          if (!
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2161; /* *truncddsf2 */

        case 23:
          if (!
#line 5896 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2165; /* *truncsdsf2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_91 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s390_unsigned_integer_comparison (x5, E_VOIDmode))
        return -1;
      operands[0] = x5;
      switch (pattern118 (x1))
        {
        case 0:
          if (!(
#line 1665 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1803; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1665 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1804; /* *cmp_and_br_unsigned_si */

        case 2:
          if (!(
#line 1723 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1807; /* *icmp_and_br_unsigned_di */

        case 3:
          if (!
#line 1723 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1808; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_105 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_100 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != 0L)
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 4408 "../../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1946; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4408 "../../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          return 1947; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode
          || pattern90 (x1) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!nonzero_shift_count_operand (operands[4], E_DImode)
          || !
#line 4327 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
        return -1;
      return 1925; /* *extzvdi_clobbercc_lshiftrt */

    case IOR:
      return recog_103 (x1, insn, pnum_clobbers);

    case NE:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x5, 2);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4360 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
            return -1;
          return 1931; /* *extract1bitdi_clobbercc */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCZ1mode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 2302; /* sne */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1948; /* *pre_z10_extvdi */

        case 1:
          return 1949; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case XOR:
      return recog_107 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5514 "../../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2038; /* *fixuns_truncdfdi2_z13 */
            }
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2044; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2040; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2042; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2046; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2048; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2050; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5514 "../../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 764 "../../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          *pnum_clobbers = 1;
          return 2039; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2047; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2041; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2043; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2045; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2049; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5529 "../../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2051; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5552 "../../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2052; /* *fix_truncdfdi2_bfp_z13 */
            }
          if (!(
#line 5565 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2058; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5565 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2054; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5565 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2056; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5565 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2060; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5599 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2062; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5599 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2063; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5552 "../../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 764 "../../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            {
              *pnum_clobbers = 1;
              return 2053; /* *fix_truncsfsi2_bfp_z13 */
            }
          if (!
#line 5565 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2061; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5565 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2055; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5565 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2057; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5565 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2059; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2166; /* *extendtftd2 */

        case 1:
          if (!(
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2167; /* *extendfprx2td2 */

        case 2:
          if (!
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2168; /* *extenddftd2 */

        case 3:
          if (!
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2169; /* *extendsftd2 */

        case 4:
          if (!(
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2170; /* *extendtfdd2 */

        case 5:
          if (!(
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2171; /* *extendfprx2dd2 */

        case 6:
          if (!
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2172; /* *extenddfdd2 */

        case 7:
          if (!
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2173; /* *extendsfdd2 */

        case 8:
          if (!(
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2174; /* *extendtfsd2 */

        case 9:
          if (!(
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2175; /* *extendfprx2sd2 */

        case 10:
          if (!
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2176; /* *extenddfsd2 */

        case 11:
          if (!
#line 5961 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2177; /* *extendsfsd2 */

        case 12:
          if (!(
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2178; /* *extendtdtf2 */

        case 13:
          if (!(
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2182; /* *extendddtf2 */

        case 14:
          if (!(
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2186; /* *extendsdtf2 */

        case 15:
          if (!(
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2179; /* *extendtdfprx22 */

        case 16:
          if (!(
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2183; /* *extendddfprx22 */

        case 17:
          if (!(
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2187; /* *extendsdfprx22 */

        case 18:
          if (!
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2180; /* *extendtddf2 */

        case 19:
          if (!
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2184; /* *extenddddf2 */

        case 20:
          if (!
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2188; /* *extendsddf2 */

        case 21:
          if (!
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2181; /* *extendtdsf2 */

        case 22:
          if (!
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2185; /* *extendddsf2 */

        case 23:
          if (!
#line 5969 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2189; /* *extendsdsf2 */

        default:
          return -1;
        }

    case NOT:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (pattern193 (x3))
            {
            case 0:
              if (!(
#line 8654 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2397; /* *notdi */

            case 1:
              if (!
#line 8654 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2398; /* *notsi */

            default:
              return -1;
            }

        case XOR:
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          x10 = XEXP (x5, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern227 (x3, 
E_DImode) != 0
                  || !(
#line 9059 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2414; /* *nxordi */

            case E_SImode:
              if (pattern227 (x3, 
E_SImode) != 0
                  || !
#line 9059 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2415; /* *nxorsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_106 (x1, insn, pnum_clobbers);

    case ABS:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern178 (x3) != 0
              || !
#line 9297 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2444; /* *absdi2_sign */

        case REG:
        case SUBREG:
          switch (pattern179 (x3))
            {
            case 0:
              if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2449; /* absdi2 */

            case 1:
              return 2450; /* abssi2 */

            case 2:
              if (!(
#line 9385 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2465; /* *abstf2 */

            case 3:
              if (!(
#line 9385 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2466; /* *absfprx22 */

            case 4:
              if (!
#line 9385 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2467; /* *absdf2 */

            case 5:
              if (!
#line 9385 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2468; /* *abssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern39 (x13) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (pattern193 (x3))
        {
        case 0:
          if (
#line 9727 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2510; /* *ashrdi3_31 */
          if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2513; /* *ashrdi3 */

        case 1:
          return 2516; /* *ashrsi3 */

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x14 = XEXP (x13, 0);
      operands[3] = x14;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      if (bras_sym_operand (operands[1], E_VOIDmode))
        {
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 10968 "../../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
            return 2574; /* *bras_r */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 10981 "../../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
            return 2575; /* *brasl_r */
        }
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (address_operand (operands[1], E_VOIDmode)
          && 
#line 10995 "../../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2576; /* *basr_r */
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 11019 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2577; /* *basr_r_via_thunk_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if ((
#line 11042 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2578; /* *basr_r_via_thunk */
        }
      if (!(
#line 11042 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2579; /* *basr_r_via_thunk */

    case POPCOUNT:
      if (pattern40 (x1) != 0
          || !
#line 12103 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 2636; /* *popcountdi_z15 */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 16
          || GET_MODE (x3) != E_CCRAWmode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x15 = XEXP (x13, 1);
      if (pattern152 (x15, 
E_BLKmode, 
17, 
UNSPEC_VOLATILE, 
1) != 0)
        return -1;
      x16 = XVECEXP (x3, 0, 0);
      operands[0] = x16;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x17 = XVECEXP (x15, 0, 0);
      if (!rtx_equal_p (x17, operands[0]))
        return -1;
      if (pnum_clobbers != NULL)
        {
          if (
#line 12377 "../../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 32;
              return 2648; /* tbegin_1_z13 */
            }
          if (
#line 12405 "../../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 16;
              return 2649; /* tbegin_1 */
            }
        }
      if (!
#line 12416 "../../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2650; /* tbegin_nofloat_1 */

    default:
      return -1;
    }
}
