/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 17;

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0)
        return -1;
      return 18;

    case E_TFmode:
      if (pattern0 (x3, 
E_TFmode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XEXP (x1, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[2] = x11;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern32 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern32 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern32 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 4;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 5;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 6;

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !register_operand (operands[1], E_TDmode))
        return -1;
      return 7;

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !register_operand (operands[1], E_DDmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern71 (x6); /* [-1, 1] */
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern94 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern94 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern99 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern99 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern99 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern99 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern99 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern99 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern99 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern99 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern99 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern99 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern99 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern99 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern99 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern99 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern100 (x1, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern100 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern100 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern100 (x1, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern100 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  x8 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      return pattern142 (x6, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern142 (x6, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern142 (x6, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern64 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern64 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1
      || GET_MODE (x3) != i2)
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  x8 = XVECEXP (x6, 0, 0);
  operands[3] = x8;
  if (!const_mask_operand (operands[3], E_QImode)
      || !address_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 1);
  x11 = XVECEXP (x10, 0, 0);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  return 0;
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern183 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern213 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  return 0;
}

int
pattern224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[0] = x10;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x11, 1);
  x16 = XEXP (x15, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x15, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      return pattern229 (x15, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern229 (x15, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern256 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern285 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern296 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 267; /* vec_sralv16qiv16qi */

    case 1:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 277; /* vec_sralv16qiv8hi */

    case 2:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 287; /* vec_sralv16qiv4si */

    case 3:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 268; /* vec_sralv8hiv16qi */

    case 4:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 278; /* vec_sralv8hiv8hi */

    case 5:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 288; /* vec_sralv8hiv4si */

    case 6:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 269; /* vec_sralv4siv16qi */

    case 7:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 279; /* vec_sralv4siv8hi */

    case 8:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 289; /* vec_sralv4siv4si */

    case 9:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 270; /* vec_sralv2div16qi */

    case 10:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 280; /* vec_sralv2div8hi */

    case 11:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 290; /* vec_sralv2div4si */

    case 12:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 271; /* vec_sralv1tiv16qi */

    case 13:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 281; /* vec_sralv1tiv8hi */

    case 14:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 291; /* vec_sralv1tiv4si */

    case 15:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 272; /* vec_sraltiv16qi */

    case 16:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 282; /* vec_sraltiv8hi */

    case 17:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 292; /* vec_sraltiv4si */

    case 18:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 273; /* vec_sralv4sfv16qi */

    case 19:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 283; /* vec_sralv4sfv8hi */

    case 20:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 293; /* vec_sralv4sfv4si */

    case 21:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 274; /* vec_sralv2dfv16qi */

    case 22:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 284; /* vec_sralv2dfv8hi */

    case 23:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 294; /* vec_sralv2dfv4si */

    case 24:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 275; /* vec_sralv1tfv16qi */

    case 25:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 285; /* vec_sralv1tfv8hi */

    case 26:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 295; /* vec_sralv1tfv4si */

    case 27:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 276; /* vec_sraltfv16qi */

    case 28:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 286; /* vec_sraltfv8hi */

    case 29:
      if (!
#line 1118 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 296; /* vec_sraltfv4si */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_DImode
      || pattern109 (x2, 
E_SImode) != 0
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4581 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
    return 1968; /* *risbgn_sidi_ior_and_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4581 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
    return -1;
  *pnum_clobbers = 1;
  return 1969; /* *risbg_sidi_ior_and_lshiftrt */
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      switch (GET_MODE (x4))
        {
        case E_CCVEQmode:
          if (GET_MODE (x2) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          switch (pattern185 (x2, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          switch (pattern185 (x2, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          switch (pattern186 (x2, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          switch (pattern186 (x2, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && immediate_operand (operands[1], E_HImode)
              && 
#line 1055 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (constm1_rtx, operands[1], true))))
            return 1736; /* *tmhi_full */
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_HImode)
              && const0_operand (operands[1], E_HImode)
              && 
#line 1208 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            {
              *pnum_clobbers = 1;
              return 1751; /* *tsthiCCT_cconly */
            }
          if (!s_operand (operands[0], E_HImode))
            return -1;
          if (pnum_clobbers != NULL
              && const0_operand (operands[1], E_HImode)
              && 
#line 1249 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            {
              *pnum_clobbers = 1;
              return 1755; /* *tsthi_cconly */
            }
          if (!immediate_operand (operands[1], E_HImode)
              || !
#line 1328 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_Z10))
            return -1;
          return 1761; /* *cmphi_ccs_z10 */

        case E_QImode:
          if (register_operand (operands[0], E_QImode)
              && immediate_operand (operands[1], E_QImode)
              && 
#line 1055 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (constm1_rtx, operands[1], true))))
            return 1737; /* *tmqi_full */
          if (!const0_operand (operands[1], E_QImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_QImode)
              && 
#line 1221 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return 1752; /* *tstqiCCT_cconly */
          if (pnum_clobbers == NULL
              || !s_operand (operands[0], E_QImode)
              || !
#line 1249 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1756; /* *tstqi_cconly */

        case E_DImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_DImode)
              && const0_operand (operands[1], E_DImode)
              && (
#line 1120 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1741; /* *tstdi_cconly_extimm */
            }
          if (!register_operand (operands[0], E_DImode)
              || !const0_operand (operands[1], E_DImode))
            return -1;
          if (
#line 1171 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_ZARCH))
            return 1746; /* *tstdi_cconly_31 */
          if (!(
#line 1181 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1747; /* *tstdi_cconly2 */

        case E_SImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_SImode)
              && const0_operand (operands[1], E_SImode))
            {
              if (
#line 1120 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                {
                  *pnum_clobbers = 1;
                  return 1742; /* *tstsi_cconly_extimm */
                }
              if (
#line 1158 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                {
                  *pnum_clobbers = 1;
                  return 1745; /* *tstsi_cconly */
                }
            }
          if (!register_operand (operands[0], E_SImode)
              || !const0_operand (operands[1], E_SImode)
              || !
#line 1181 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          return 1748; /* *tstsi_cconly2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || !const0_operand (operands[1], E_TFmode)
              || !(
#line 1564 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1781; /* *cmptf_ccs_0_fastmath */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || !const0_operand (operands[1], E_FPRX2mode)
              || !(
#line 1564 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1782; /* *cmpfprx2_ccs_0_fastmath */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || !const0_operand (operands[1], E_DFmode)
              || !
#line 1564 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans))
            return -1;
          return 1783; /* *cmpdf_ccs_0_fastmath */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !const0_operand (operands[1], E_SFmode)
              || !
#line 1564 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans))
            return -1;
          return 1784; /* *cmpsf_ccs_0_fastmath */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || !const0_operand (operands[1], E_TDmode)
              || !(
#line 1564 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1785; /* *cmptd_ccs_0_fastmath */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || !const0_operand (operands[1], E_DDmode)
              || !(
#line 1564 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1786; /* *cmpdd_ccs_0_fastmath */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 4360 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return 1930; /* *extract1bitdi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4360 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return -1;
      *pnum_clobbers = 1;
      return 1931; /* *extract1bitdi_clobbercc */

    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      *pnum_clobbers = 1;
      return 2302; /* sne */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      if (pattern12 (x1, 
E_V1QImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1296; /* *vec_cmpgtuv1qiv1qi_nocc */

    case E_V2QImode:
      if (pattern12 (x1, 
E_V2QImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1299; /* *vec_cmpgtuv2qiv2qi_nocc */

    case E_V4QImode:
      if (pattern12 (x1, 
E_V4QImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1302; /* *vec_cmpgtuv4qiv4qi_nocc */

    case E_V8QImode:
      if (pattern12 (x1, 
E_V8QImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1305; /* *vec_cmpgtuv8qiv8qi_nocc */

    case E_V16QImode:
      if (pattern12 (x1, 
E_V16QImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1308; /* *vec_cmpgtuv16qiv16qi_nocc */

    case E_V1HImode:
      if (pattern12 (x1, 
E_V1HImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1311; /* *vec_cmpgtuv1hiv1hi_nocc */

    case E_V2HImode:
      if (pattern12 (x1, 
E_V2HImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1314; /* *vec_cmpgtuv2hiv2hi_nocc */

    case E_V4HImode:
      if (pattern12 (x1, 
E_V4HImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1317; /* *vec_cmpgtuv4hiv4hi_nocc */

    case E_V8HImode:
      if (pattern12 (x1, 
E_V8HImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1320; /* *vec_cmpgtuv8hiv8hi_nocc */

    case E_V1SImode:
      if (pattern12 (x1, 
E_V1SImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1323; /* *vec_cmpgtuv1siv1si_nocc */

    case E_V2SImode:
      if (pattern12 (x1, 
E_V2SImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1326; /* *vec_cmpgtuv2siv2si_nocc */

    case E_V4SImode:
      if (pattern12 (x1, 
E_V4SImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1329; /* *vec_cmpgtuv4siv4si_nocc */

    case E_V1DImode:
      if (pattern12 (x1, 
E_V1DImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1332; /* *vec_cmpgtuv1div1di_nocc */

    case E_V2DImode:
      if (pattern12 (x1, 
E_V2DImode) != 0
          || !
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1335; /* *vec_cmpgtuv2div2di_nocc */

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (!register_operand (x4, E_V1TImode))
        return -1;
      operands[0] = x4;
      operands[2] = x2;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_V1TImode)
          && (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return 1338; /* *vec_cmpgtuv1tiv1ti_nocc */
      operands[1] = x4;
      operands[0] = x2;
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1TImode)
          || !
#line 2184 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1346; /* *vec_cmpgtuv1tiv1ti_nocc_emu */

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (!register_operand (x4, E_TImode))
        return -1;
      operands[0] = x4;
      operands[2] = x2;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_TImode)
          && (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return 1341; /* *vec_cmpgtutiti_nocc */
      operands[1] = x4;
      operands[0] = x2;
      operands[2] = x5;
      if (!register_operand (operands[2], E_TImode)
          || !
#line 2184 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1347; /* *vec_cmpgtutiti_nocc_emu */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern64 (x3, 
E_V1QImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 684; /* addv1qi3 */

        case E_V2QImode:
          if (pattern64 (x3, 
E_V2QImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 685; /* addv2qi3 */

        case E_V4QImode:
          if (pattern64 (x3, 
E_V4QImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 686; /* addv4qi3 */

        case E_V8QImode:
          if (pattern64 (x3, 
E_V8QImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 687; /* addv8qi3 */

        case E_V16QImode:
          if (pattern64 (x3, 
E_V16QImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 688; /* addv16qi3 */

        case E_V1HImode:
          if (pattern64 (x3, 
E_V1HImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 689; /* addv1hi3 */

        case E_V2HImode:
          if (pattern64 (x3, 
E_V2HImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 690; /* addv2hi3 */

        case E_V4HImode:
          if (pattern64 (x3, 
E_V4HImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 691; /* addv4hi3 */

        case E_V8HImode:
          if (pattern64 (x3, 
E_V8HImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 692; /* addv8hi3 */

        case E_V1SImode:
          if (pattern64 (x3, 
E_V1SImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 693; /* addv1si3 */

        case E_V2SImode:
          if (pattern64 (x3, 
E_V2SImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 694; /* addv2si3 */

        case E_V4SImode:
          if (pattern64 (x3, 
E_V4SImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 695; /* addv4si3 */

        case E_V1DImode:
          if (pattern64 (x3, 
E_V1DImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 696; /* addv1di3 */

        case E_V2DImode:
          if (pattern64 (x3, 
E_V2DImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 697; /* addv2di3 */

        case E_V1TImode:
          if (pattern64 (x3, 
E_V1TImode) != 0
              || !
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 698; /* addv1ti3 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || !nonimmediate_operand (operands[1], E_TImode)
              || !general_operand (operands[2], E_TImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_TImode)
              && 
#line 1128 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 699; /* *addti3 */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || !
#line 6065 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2190; /* *addti3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 1853 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1227; /* addv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 1853 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1228; /* addv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 1853 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1229; /* addv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1853 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1230; /* addtf3_vr */
          if (pnum_clobbers == NULL
              || !nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 6483 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2220; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pnum_clobbers == NULL
              || pattern174 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6483 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2221; /* addfprx23 */

        case E_DFmode:
          if (pnum_clobbers == NULL
              || pattern174 (x3, 
E_DFmode) != 0
              || !
#line 6483 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2222; /* adddf3 */

        case E_SFmode:
          if (pnum_clobbers == NULL
              || pattern174 (x3, 
E_SFmode) != 0
              || !
#line 6483 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2223; /* addsf3 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || pattern174 (x3, 
E_TDmode) != 0
              || !(
#line 6483 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2224; /* addtd3 */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || pattern174 (x3, 
E_DDmode) != 0
              || !(
#line 6483 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2225; /* adddd3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!register_operand (x5, E_DImode))
        return -1;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x5;
          switch (XWINT (x7, 0))
            {
            case 1L:
              if (!
#line 2079 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1820; /* *lxah_index_base */

            case 2L:
              if (!
#line 2079 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1821; /* *lxaf_index_base */

            case 3L:
              if (!
#line 2079 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1822; /* *lxag_index_base */

            case 4L:
              if (!
#line 2079 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1823; /* *lxaq_index_base */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x5;
          switch (XWINT (x7, 0))
            {
            case 1L:
              if (!
#line 2090 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1824; /* *lxah_displacement_index_base */

            case 2L:
              if (!
#line 2090 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1825; /* *lxaf_displacement_index_base */

            case 3L:
              if (!
#line 2090 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1826; /* *lxag_displacement_index_base */

            case 4L:
              if (!
#line 2090 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1827; /* *lxaq_displacement_index_base */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern112 (x3) != 0
          || !
#line 2099 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
        return -1;
      return 1828; /* *lxab_displacement_index_base */

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (register_operand (operands[1], E_DImode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_DImode))
            {
              switch (pattern270 (x4))
                {
                case 0:
                  if (
#line 2127 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                    return 1833; /* *llxah_index_base */
                  break;

                case 1:
                  if (
#line 2127 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                    return 1834; /* *llxaf_index_base */
                  break;

                case 2:
                  if (
#line 2127 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                    return 1835; /* *llxag_index_base */
                  break;

                case 3:
                  if (
#line 2127 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                    return 1836; /* *llxaq_index_base */
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_CODE (x8) != SUBREG
          || maybe_ne (SUBREG_BYTE (x8), 0)
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      switch (pattern270 (x4))
        {
        case 0:
          if (!
#line 2140 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1837; /* *llxah_displacement_index_base */

        case 1:
          if (!
#line 2140 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1838; /* *llxaf_displacement_index_base */

        case 2:
          if (!
#line 2140 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1839; /* *llxag_displacement_index_base */

        case 3:
          if (!
#line 2140 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1840; /* *llxaq_displacement_index_base */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern112 (x3) != 0
          || !
#line 2149 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
        return -1;
      return 1841; /* *llxab_displacement_index_base */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return 990; /* *ashrv1qi3 */
      if (!register_operand (operands[2], E_V1QImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1059; /* vashrv1qi3 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return 994; /* *ashrv2qi3 */
      if (!register_operand (operands[2], E_V2QImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1060; /* vashrv2qi3 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return 998; /* *ashrv4qi3 */
      if (!register_operand (operands[2], E_V4QImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1061; /* vashrv4qi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return 1002; /* *ashrv8qi3 */
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1062; /* vashrv8qi3 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return 1006; /* *ashrv16qi3 */
      if (!register_operand (operands[2], E_V16QImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1063; /* vashrv16qi3 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return 1010; /* *ashrv1hi3 */
      if (!register_operand (operands[2], E_V1HImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1064; /* vashrv1hi3 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return 1014; /* *ashrv2hi3 */
      if (!register_operand (operands[2], E_V2HImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1065; /* vashrv2hi3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return 1018; /* *ashrv4hi3 */
      if (!register_operand (operands[2], E_V4HImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1066; /* vashrv4hi3 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return 1022; /* *ashrv8hi3 */
      if (!register_operand (operands[2], E_V8HImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1067; /* vashrv8hi3 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return 1026; /* *ashrv1si3 */
      if (!register_operand (operands[2], E_V1SImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1068; /* vashrv1si3 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return 1030; /* *ashrv2si3 */
      if (!register_operand (operands[2], E_V2SImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1069; /* vashrv2si3 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return 1034; /* *ashrv4si3 */
      if (!register_operand (operands[2], E_V4SImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1070; /* vashrv4si3 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return 1038; /* *ashrv1di3 */
      if (!register_operand (operands[2], E_V1DImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1071; /* vashrv1di3 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return 1042; /* *ashrv2di3 */
      if (!register_operand (operands[2], E_V2DImode)
          || !
#line 1557 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1072; /* vashrv2di3 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern10 (x3, 
E_DImode) != 0)
        return -1;
      if (
#line 9727 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2510; /* *ashrdi3_31 */
        }
      if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2513; /* *ashrdi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern10 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2516; /* *ashrsi3 */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern11 (x3))
    {
    case 0:
      if (register_operand (operands[2], E_V1QImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 975; /* vrotlv1qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return -1;
      return 992; /* *rotlv1qi3 */

    case 1:
      if (register_operand (operands[2], E_V2QImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 976; /* vrotlv2qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return -1;
      return 996; /* *rotlv2qi3 */

    case 2:
      if (register_operand (operands[2], E_V4QImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 977; /* vrotlv4qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return -1;
      return 1000; /* *rotlv4qi3 */

    case 3:
      if (register_operand (operands[2], E_V8QImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 978; /* vrotlv8qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return -1;
      return 1004; /* *rotlv8qi3 */

    case 4:
      if (register_operand (operands[2], E_V16QImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 979; /* vrotlv16qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return -1;
      return 1008; /* *rotlv16qi3 */

    case 5:
      if (register_operand (operands[2], E_V1HImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 980; /* vrotlv1hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return -1;
      return 1012; /* *rotlv1hi3 */

    case 6:
      if (register_operand (operands[2], E_V2HImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 981; /* vrotlv2hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return -1;
      return 1016; /* *rotlv2hi3 */

    case 7:
      if (register_operand (operands[2], E_V4HImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 982; /* vrotlv4hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return -1;
      return 1020; /* *rotlv4hi3 */

    case 8:
      if (register_operand (operands[2], E_V8HImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 983; /* vrotlv8hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return -1;
      return 1024; /* *rotlv8hi3 */

    case 9:
      if (register_operand (operands[2], E_V1SImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 984; /* vrotlv1si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return -1;
      return 1028; /* *rotlv1si3 */

    case 10:
      if (register_operand (operands[2], E_V2SImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 985; /* vrotlv2si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return -1;
      return 1032; /* *rotlv2si3 */

    case 11:
      if (register_operand (operands[2], E_V4SImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 986; /* vrotlv4si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return -1;
      return 1036; /* *rotlv4si3 */

    case 12:
      if (register_operand (operands[2], E_V1DImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 987; /* vrotlv1di3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return -1;
      return 1040; /* *rotlv1di3 */

    case 13:
      if (register_operand (operands[2], E_V2DImode)
          && 
#line 1457 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 988; /* vrotlv2di3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1516 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return -1;
      return 1044; /* *rotlv2di3 */

    case 14:
      if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2502; /* *rotldi3 */

    case 15:
      return 2503; /* *rotlsi3 */

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_31 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_32 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!s390_comparison (x3, E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      operands[2] = x4;
      if (cc_reg_operand (operands[2], E_VOIDmode))
        {
          res = recog_33 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (REGNO (x4) != 33)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) == PC)
            {
              operands[1] = x3;
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == PC)
                    {
                      x9 = XEXP (x7, 0);
                      operands[0] = x9;
                      return 2519; /* *cjump_64 */
                    }
                  break;

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == LABEL_REF)
                    {
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      return 2523; /* *icjump_64 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 0L)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          operands[0] = x7;
          if (!address_operand (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[1] = x3;
          if (!
#line 9818 "../../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2520; /* *cjump_long */

        case RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9841 "../../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
            return -1;
          return 2521; /* *creturn */

        case SIMPLE_RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9841 "../../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
            return -1;
          return 2522; /* *csimple_return */

        case PC:
          operands[1] = x3;
          x8 = XEXP (x2, 2);
          operands[0] = x8;
          if (!address_operand (operands[0], E_VOIDmode)
              || !
#line 9895 "../../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2524; /* *icjump_long */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || GET_MODE (x5) != E_DFmode
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 3100 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1557; /* *trunctfdf2_vr */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_TDmode)
              || GET_MODE (x5) != E_DImode
              || !const_mask_operand (operands[2], E_DImode)
              || !
#line 5735 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2093; /* *trunctddd2 */

        default:
          return -1;
        }

    case CLOBBER:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_TFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 5712 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2091; /* trunctfdf2_fpr */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 5712 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2092; /* trunctfsf2_fpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) == 2147483647L
              && pattern38 (x1) == 0
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              operands[1] = x4;
              if (address_operand (operands[1], E_QImode)
                  && 
#line 2582 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1851; /* *la_31_and_cc */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_92 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_93 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 33
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (GET_CODE (x4) == SUBREG)
        {
          res = recog_94 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern121 (x3, 
E_DImode) != 0
              || !
#line 7954 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2342; /* *anddi3 */

        case E_SImode:
          if (pattern121 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 8083 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2353; /* *andsi3_zarch */
          if (!
#line 8117 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2354; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x4) != E_DImode
          || pattern38 (x1) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!contiguous_bitmask_operand (operands[3], E_DImode)
          || !
#line 4397 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      return 1945; /* *risbg_di_and_rot */

    case LSHIFTRT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern89 (x6) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode))
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[1] = x12;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          x13 = XEXP (x8, 2);
          operands[2] = x13;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !
#line 4843 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
            return -1;
          return 1999; /* *insv_rnsbg_srl */

        case CONST_INT:
          operands[3] = x5;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern246 (x3, 
E_DImode) != 0
                  || !(
#line 8004 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2344; /* *extzv_di_srl_clobbercc */

            case E_SImode:
              if (pattern246 (x3, 
E_SImode) != 0
                  || !
#line 8004 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
                return -1;
              return 2346; /* *extzv_si_srl_clobbercc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern246 (x3, 
E_DImode) != 0
              || !(
#line 8018 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2348; /* *extzv_di_sll_clobbercc */

        case E_SImode:
          if (pattern246 (x3, 
E_SImode) != 0
              || !
#line 8018 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          return 2350; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8226 "../../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2359; /* *andc_split_di */
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8605 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2381; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8226 "../../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                return 2360; /* *andc_split_si */
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8605 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2383; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern216 (x3))
            {
            case 0:
              if (!(
#line 8645 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2393; /* *nordi */

            case 1:
              if (!
#line 8645 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2395; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern93 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern250 (x4, 
E_DImode) != 0
                  || !(
#line 4678 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1975; /* *rxsbg_di_noshift */

            case E_SImode:
              if (pattern250 (x4, 
E_SImode) != 0
                  || !
#line 4678 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1977; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4693 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1979; /* *rxsbg_di_rotl */

        case 2:
          if (!(
#line 4708 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1981; /* *rxsbg_di_srl_bitmask */

        case 3:
          if (!
#line 4708 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1983; /* *rxsbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4728 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1985; /* *rxsbg_di_sll_bitmask */

        case 5:
          if (!
#line 4728 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1987; /* *rxsbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4746 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1989; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4746 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1991; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4765 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1993; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4765 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1995; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern119 (x1) == 0
          && 
#line 4785 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 1997; /* *rxsbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern120 (x1) == 0
          && 
#line 8941 "../../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2408; /* *xc */
        }
      operands[1] = x5;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 8785 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2402; /* *xordi3 */

        case 1:
          if (!
#line 8855 "../../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2405; /* *xorsi3 */

        case 2:
          if (!
#line 8888 "../../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2406; /* *xorhi3 */

        case 3:
          if (!
#line 8918 "../../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2407; /* *xorqi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (pnum_clobbers == NULL
              || pattern98 (x4) != 0)
            return -1;
          switch (pattern258 (x1))
            {
            case 0:
              if (!(
#line 3691 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1888; /* *cpymem_long */

            case 1:
              if (!(
#line 3691 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1889; /* *cpymem_long */

            case 2:
              if (!
#line 3704 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 1890; /* *cpymem_long_31z */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x9) != E_CCUmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SUBREG)
            return -1;
          x14 = XEXP (x4, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 33
              || GET_MODE (x14) != E_CCUmode)
            return -1;
          x15 = XEXP (x11, 0);
          operands[2] = x15;
          x16 = XEXP (x13, 0);
          operands[3] = x16;
          x17 = XEXP (x5, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x6, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (SUBREG_BYTE (x11))
            {
            case 0:
              if (maybe_ne (SUBREG_BYTE (x13), 0))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pattern296 (x9, 
E_TImode, 
E_DImode) != 0
                      || !(
#line 4144 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                    return -1;
                  return 1910; /* *cmpmem_long */

                case E_DImode:
                  if (pattern296 (x9, 
E_DImode, 
E_SImode) != 0
                      || !(
#line 4144 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                    return -1;
                  return 1911; /* *cmpmem_long */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x11) != E_SImode
                  || maybe_ne (SUBREG_BYTE (x13), 4)
                  || GET_MODE (x13) != E_SImode
                  || !register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !register_operand (operands[2], E_TImode)
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 4157 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1912; /* *cmpmem_long_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x19 = XEXP (x2, 1);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 0L)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x5, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[3]))
            {
            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !(
#line 3842 "../../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1900; /* *clrmem_short */

            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !(
#line 3842 "../../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1901; /* *clrmem_short */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[2] = x20;
          switch (pattern272 (x1))
            {
            case 0:
              if (!
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2661; /* split_stack_calldi */

            case 1:
              if (!
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2662; /* split_stack_callsi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != LABEL_REF)
            return -1;
          x22 = XEXP (x19, 2);
          if (GET_CODE (x22) != PC
              || pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[5] = x20;
          x23 = XEXP (x21, 0);
          operands[2] = x23;
          switch (pattern272 (x1))
            {
            case 0:
              if (!
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2663; /* split_stack_cond_calldi */

            case 1:
              if (!
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2664; /* split_stack_cond_callsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_153 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_162 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_171 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_189 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_207 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_225 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_234 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_243 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_252 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_261 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_270 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_279 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_145 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_154 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_163 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_181 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_190 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_217 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_226 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_235 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_244 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_253 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_262 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_271 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_280 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_146 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_164 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_182 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_191 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_209 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_218 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_236 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_245 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_254 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_263 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_272 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_281 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ASHIFT)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern181 (x3, 
E_DImode) != 0
              || !(
#line 4624 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_342 (insn, operands);

        case E_SImode:
          if (pattern181 (x3, 
E_SImode) != 0
              || !
#line 4624 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
            return NULL;
          return gen_split_343 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_BLKmode)
      || !memory_operand (operands[1], E_BLKmode))
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (pattern197 (x4, 
2) != 0)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!memory_operand (operands[3], E_BLKmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_BLKmode))
    return NULL;
  x8 = XVECEXP (x4, 0, 1);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !
#line 3135 "../../../gcc/config/s390/s390.md"
(((INTVAL (operands[2]) > 16 && INTVAL (operands[5]) > 16)
    || (INTVAL (operands[2]) + INTVAL (operands[5]) <= 16))
   && s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_18 (insn, operands);
}
