/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_DImode:
      if (pattern10 (x1, 
E_DImode) != 0)
        return -1;
      return 14;

    case E_SImode:
      if (pattern10 (x1, 
E_SImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 8);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x16 = XVECEXP (x4, 0, 9);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x4, 0, 10);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x18 = XVECEXP (x4, 0, 11);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x19 = XVECEXP (x4, 0, 12);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x4, 0, 13);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x21 = XVECEXP (x4, 0, 14);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XVECEXP (x4, 0, 15);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != USE
          || !nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16QImode))
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != CLOBBER)
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!scratch_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 1;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 26)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != LABEL_REF)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != USE)
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern91 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern91 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG)
    return -1;
  return 0;
}

int
pattern107 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x4, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x5, 0);
  operands[2] = x12;
  x13 = XEXP (x8, 0);
  operands[0] = x13;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x7, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x9, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern187 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  return 0;
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern255 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_V8HImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 207; /* vec_sllv16qiv16qi */

    case 1:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 217; /* vec_sllv16qiv8hi */

    case 2:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 227; /* vec_sllv16qiv4si */

    case 3:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 208; /* vec_sllv8hiv16qi */

    case 4:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 218; /* vec_sllv8hiv8hi */

    case 5:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 228; /* vec_sllv8hiv4si */

    case 6:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 209; /* vec_sllv4siv16qi */

    case 7:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 219; /* vec_sllv4siv8hi */

    case 8:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 229; /* vec_sllv4siv4si */

    case 9:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 210; /* vec_sllv2div16qi */

    case 10:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 220; /* vec_sllv2div8hi */

    case 11:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 230; /* vec_sllv2div4si */

    case 12:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 211; /* vec_sllv1tiv16qi */

    case 13:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 221; /* vec_sllv1tiv8hi */

    case 14:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 231; /* vec_sllv1tiv4si */

    case 15:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 212; /* vec_slltiv16qi */

    case 16:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 222; /* vec_slltiv8hi */

    case 17:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 232; /* vec_slltiv4si */

    case 18:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 213; /* vec_sllv4sfv16qi */

    case 19:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 223; /* vec_sllv4sfv8hi */

    case 20:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 233; /* vec_sllv4sfv4si */

    case 21:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 214; /* vec_sllv2dfv16qi */

    case 22:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 224; /* vec_sllv2dfv8hi */

    case 23:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_sllv2dfv4si */

    case 24:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 215; /* vec_sllv1tfv16qi */

    case 25:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 225; /* vec_sllv1tfv8hi */

    case 26:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_sllv1tfv4si */

    case 27:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 216; /* vec_slltfv16qi */

    case 28:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 226; /* vec_slltfv8hi */

    case 29:
      if (!
#line 1049 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_slltfv4si */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern130 (x2, 
E_V1QImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 794; /* notandv1qi3 */

        case E_V2QImode:
          if (pattern130 (x2, 
E_V2QImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 795; /* notandv2qi3 */

        case E_V4QImode:
          if (pattern130 (x2, 
E_V4QImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 796; /* notandv4qi3 */

        case E_V8QImode:
          if (pattern130 (x2, 
E_V8QImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 797; /* notandv8qi3 */

        case E_V16QImode:
          if (pattern130 (x2, 
E_V16QImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 798; /* notandv16qi3 */

        case E_V1HImode:
          if (pattern130 (x2, 
E_V1HImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 799; /* notandv1hi3 */

        case E_V2HImode:
          if (pattern130 (x2, 
E_V2HImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 800; /* notandv2hi3 */

        case E_V4HImode:
          if (pattern130 (x2, 
E_V4HImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 801; /* notandv4hi3 */

        case E_V8HImode:
          if (pattern130 (x2, 
E_V8HImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 802; /* notandv8hi3 */

        case E_V1SImode:
          if (pattern130 (x2, 
E_V1SImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 803; /* notandv1si3 */

        case E_V2SImode:
          if (pattern130 (x2, 
E_V2SImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 804; /* notandv2si3 */

        case E_V4SImode:
          if (pattern130 (x2, 
E_V4SImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 805; /* notandv4si3 */

        case E_V1DImode:
          if (pattern130 (x2, 
E_V1DImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 806; /* notandv1di3 */

        case E_V2DImode:
          if (pattern130 (x2, 
E_V2DImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 807; /* notandv2di3 */

        case E_V1SFmode:
          if (pattern130 (x2, 
E_V1SFmode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 808; /* notandv1sf3 */

        case E_V2SFmode:
          if (pattern130 (x2, 
E_V2SFmode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 809; /* notandv2sf3 */

        case E_V4SFmode:
          if (pattern130 (x2, 
E_V4SFmode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 810; /* notandv4sf3 */

        case E_V1DFmode:
          if (pattern130 (x2, 
E_V1DFmode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 811; /* notandv1df3 */

        case E_V2DFmode:
          if (pattern130 (x2, 
E_V2DFmode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 812; /* notandv2df3 */

        case E_V1TFmode:
          if (pattern130 (x2, 
E_V1TFmode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 813; /* notandv1tf3 */

        case E_V1TImode:
          if (pattern130 (x2, 
E_V1TImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 814; /* notandv1ti3 */

        case E_TImode:
          if (pattern130 (x2, 
E_TImode) != 0
              || !
#line 1266 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 815; /* notandti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_DImode) != 0
              || !(
#line 8645 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2394; /* *nanddi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_SImode) != 0
              || !
#line 8645 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2396; /* *nandsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern81 (x2, 
E_V1QImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 838; /* ior_notv1qi3 */

        case E_V2QImode:
          if (pattern81 (x2, 
E_V2QImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 839; /* ior_notv2qi3 */

        case E_V4QImode:
          if (pattern81 (x2, 
E_V4QImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 840; /* ior_notv4qi3 */

        case E_V8QImode:
          if (pattern81 (x2, 
E_V8QImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 841; /* ior_notv8qi3 */

        case E_V16QImode:
          if (pattern81 (x2, 
E_V16QImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 842; /* ior_notv16qi3 */

        case E_V1HImode:
          if (pattern81 (x2, 
E_V1HImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 843; /* ior_notv1hi3 */

        case E_V2HImode:
          if (pattern81 (x2, 
E_V2HImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 844; /* ior_notv2hi3 */

        case E_V4HImode:
          if (pattern81 (x2, 
E_V4HImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 845; /* ior_notv4hi3 */

        case E_V8HImode:
          if (pattern81 (x2, 
E_V8HImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 846; /* ior_notv8hi3 */

        case E_V1SImode:
          if (pattern81 (x2, 
E_V1SImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 847; /* ior_notv1si3 */

        case E_V2SImode:
          if (pattern81 (x2, 
E_V2SImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 848; /* ior_notv2si3 */

        case E_V4SImode:
          if (pattern81 (x2, 
E_V4SImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 849; /* ior_notv4si3 */

        case E_V1DImode:
          if (pattern81 (x2, 
E_V1DImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 850; /* ior_notv1di3 */

        case E_V2DImode:
          if (pattern81 (x2, 
E_V2DImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 851; /* ior_notv2di3 */

        case E_V1SFmode:
          if (pattern81 (x2, 
E_V1SFmode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 852; /* ior_notv1sf3 */

        case E_V2SFmode:
          if (pattern81 (x2, 
E_V2SFmode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 853; /* ior_notv2sf3 */

        case E_V4SFmode:
          if (pattern81 (x2, 
E_V4SFmode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 854; /* ior_notv4sf3 */

        case E_V1DFmode:
          if (pattern81 (x2, 
E_V1DFmode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 855; /* ior_notv1df3 */

        case E_V2DFmode:
          if (pattern81 (x2, 
E_V2DFmode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 856; /* ior_notv2df3 */

        case E_V1TFmode:
          if (pattern81 (x2, 
E_V1TFmode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 857; /* ior_notv1tf3 */

        case E_V1TImode:
          if (pattern81 (x2, 
E_V1TImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 858; /* ior_notv1ti3 */

        case E_TImode:
          if (pattern81 (x2, 
E_TImode) != 0
              || !
#line 1286 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 859; /* ior_notti3 */

        case E_DImode:
          if (pattern82 (x2, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8605 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2382; /* *orcdi */

        case E_SImode:
          if (pattern82 (x2, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8605 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2384; /* *orcsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4327 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return 1924; /* *extzvdi_nocc_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4327 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return -1;
  *pnum_clobbers = 1;
  return 1925; /* *extzvdi_clobbercc_lshiftrt */
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == EQ)
    {
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  if (!s390_signed_integer_comparison (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) == PC)
    {
      x8 = XEXP (x2, 2);
      switch (pattern172 (x8))
        {
        case 0:
          if ((
#line 1695 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1805; /* *icmp_and_br_signed_di */
            }
          break;

        case 1:
          if (
#line 1695 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            {
              *pnum_clobbers = 1;
              return 1806; /* *icmp_and_br_signed_si */
            }
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  switch (pattern171 (x2))
    {
    case 0:
      if (!(
#line 1637 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1801; /* *cmp_and_br_signed_di */

    case 1:
      if (!
#line 1637 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
        return -1;
      *pnum_clobbers = 1;
      return 1802; /* *cmp_and_br_signed_si */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern233 (x3, 
E_DImode) != 0
          || !(
#line 7363 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2305; /* *movdicc */

    case E_SImode:
      if (pattern233 (x3, 
E_SImode) != 0
          || !
#line 7363 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      return 2306; /* *movsicc */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1295; /* *vec_cmpgtv1qiv1qi_nocc */

    case 1:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1298; /* *vec_cmpgtv2qiv2qi_nocc */

    case 2:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1301; /* *vec_cmpgtv4qiv4qi_nocc */

    case 3:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1304; /* *vec_cmpgtv8qiv8qi_nocc */

    case 4:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1307; /* *vec_cmpgtv16qiv16qi_nocc */

    case 5:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1310; /* *vec_cmpgtv1hiv1hi_nocc */

    case 6:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1313; /* *vec_cmpgtv2hiv2hi_nocc */

    case 7:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1316; /* *vec_cmpgtv4hiv4hi_nocc */

    case 8:
      if (!
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1319; /* *vec_cmpgtv8hiv8hi_nocc */

    case 9:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1SImode)
              && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1322; /* *vec_cmpgtv1siv1si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1SFmode))
        return -1;
      if (
#line 2277 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1376; /* *vec_cmpgtv1sf_signaling_nocc */
      if (!(
#line 2285 "../../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1383; /* *vec_cmpgtv1sf_signaling_finite_nocc */

    case 10:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2SImode)
              && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1325; /* *vec_cmpgtv2siv2si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2SFmode))
        return -1;
      if (
#line 2277 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1377; /* *vec_cmpgtv2sf_signaling_nocc */
      if (!(
#line 2285 "../../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1384; /* *vec_cmpgtv2sf_signaling_finite_nocc */

    case 11:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V4SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V4SImode)
              && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1328; /* *vec_cmpgtv4siv4si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      if (
#line 2277 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1378; /* *vec_cmpgtv4sf_signaling_nocc */
      if (!(
#line 2285 "../../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1385; /* *vec_cmpgtv4sf_signaling_finite_nocc */

    case 12:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1DImode)
              && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1331; /* *vec_cmpgtv1div1di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1DFmode))
        return -1;
      if (
#line 2277 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1379; /* *vec_cmpgtv1df_signaling_nocc */
      if (!
#line 2285 "../../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1386; /* *vec_cmpgtv1df_signaling_finite_nocc */

    case 13:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2DImode)
              && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1334; /* *vec_cmpgtv2div2di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DFmode))
        return -1;
      if (
#line 2277 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1380; /* *vec_cmpgtv2df_signaling_nocc */
      if (!
#line 2285 "../../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1387; /* *vec_cmpgtv2df_signaling_finite_nocc */

    case 14:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1TImode)
              && (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1337; /* *vec_cmpgtv1tiv1ti_nocc */
        }
      operands[0] = x2;
      switch (pattern110 (x3))
        {
        case 0:
          if (!
#line 2150 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1344; /* *vec_cmpgtv1tiv1ti_nocc_emu */

        case 1:
          if (
#line 2277 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1381; /* *vec_cmpgtv1tf_signaling_nocc */
          if (!(
#line 2285 "../../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1388; /* *vec_cmpgtv1tf_signaling_finite_nocc */

        default:
          return -1;
        }

    case 15:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_TImode)
              && (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1340; /* *vec_cmpgttiti_nocc */
        }
      operands[0] = x2;
      switch (pattern111 (x3))
        {
        case 0:
          if (!
#line 2150 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1345; /* *vec_cmpgttiti_nocc_emu */

        case 1:
          if (
#line 2277 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1382; /* *vec_cmpgttf_signaling_nocc */
          if (!(
#line 2285 "../../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1389; /* *vec_cmpgttf_signaling_finite_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 1146 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 716; /* mulv16qi3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 1146 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 717; /* mulv8hi3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 1146 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 718; /* mulv4si3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !(
#line 1146 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 719; /* mulv2di3 */

        case E_V1TImode:
          if (pattern0 (x3, 
E_V1TImode) != 0
              || !(
#line 1146 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 720; /* mulv1ti3 */

        case E_TImode:
          if (pattern0 (x3, 
E_TImode) != 0
              || !(
#line 1146 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 721; /* multi3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 1885 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1235; /* mulv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 1885 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1236; /* mulv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 1885 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1237; /* mulv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1885 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1238; /* multf3_vr */
          if (!nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 7573 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2319; /* multf3_fpr */

        case E_FPRX2mode:
          if (pattern174 (x3, 
E_FPRX2mode) != 0
              || !(
#line 7573 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2320; /* mulfprx23 */

        case E_DFmode:
          if (pattern174 (x3, 
E_DFmode) != 0
              || !
#line 7573 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2321; /* muldf3 */

        case E_SFmode:
          if (pattern174 (x3, 
E_SFmode) != 0
              || !
#line 7573 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2322; /* mulsf3 */

        case E_TDmode:
          if (pattern174 (x3, 
E_TDmode) != 0
              || !(
#line 7573 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2323; /* multd3 */

        case E_DDmode:
          if (pattern174 (x3, 
E_DDmode) != 0
              || !(
#line 7573 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2324; /* muldd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_TImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (nonimmediate_operand (operands[2], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7426 "../../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return 2309; /* mulditi3 */
      if (!register_operand (operands[2], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !
#line 7439 "../../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return -1;
      return 2310; /* mulditi3_2 */

    case ZERO_EXTEND:
      if (pattern113 (x3, 
E_DImode, 
E_TImode) != 0
          || !
#line 779 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2317; /* umulditi3 */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case IOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern105 (x3, 
E_V16QImode) != 0
              || !
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 194; /* vec_norv16qi3 */

        case E_V8HImode:
          if (pattern105 (x3, 
E_V8HImode) != 0
              || !
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 195; /* vec_norv8hi3 */

        case E_V4SImode:
          if (pattern105 (x3, 
E_V4SImode) != 0
              || !
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 196; /* vec_norv4si3 */

        case E_V2DImode:
          if (pattern105 (x3, 
E_V2DImode) != 0
              || !
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 197; /* vec_norv2di3 */

        case E_V2DFmode:
          if (pattern105 (x3, 
E_V2DFmode) != 0
              || !
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 198; /* vec_norv2df3 */

        case E_V1TImode:
          if (pattern105 (x3, 
E_V1TImode) != 0
              || !
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 199; /* vec_norv1ti3 */

        case E_TImode:
          if (pattern105 (x3, 
E_TImode) != 0
              || !
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 200; /* vec_norti3 */

        case E_V4SFmode:
          if (pattern105 (x3, 
E_V4SFmode) != 0
              || !(
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 201; /* vec_norv4sf3 */

        case E_V1TFmode:
          if (pattern105 (x3, 
E_V1TFmode) != 0
              || !(
#line 1017 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 202; /* vec_norv1tf3 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern105 (x3, 
E_V1QImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 882; /* notxorv1qi3 */

        case E_V2QImode:
          if (pattern105 (x3, 
E_V2QImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 883; /* notxorv2qi3 */

        case E_V4QImode:
          if (pattern105 (x3, 
E_V4QImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 884; /* notxorv4qi3 */

        case E_V8QImode:
          if (pattern105 (x3, 
E_V8QImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 885; /* notxorv8qi3 */

        case E_V16QImode:
          if (pattern105 (x3, 
E_V16QImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 886; /* notxorv16qi3 */

        case E_V1HImode:
          if (pattern105 (x3, 
E_V1HImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 887; /* notxorv1hi3 */

        case E_V2HImode:
          if (pattern105 (x3, 
E_V2HImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 888; /* notxorv2hi3 */

        case E_V4HImode:
          if (pattern105 (x3, 
E_V4HImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 889; /* notxorv4hi3 */

        case E_V8HImode:
          if (pattern105 (x3, 
E_V8HImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 890; /* notxorv8hi3 */

        case E_V1SImode:
          if (pattern105 (x3, 
E_V1SImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 891; /* notxorv1si3 */

        case E_V2SImode:
          if (pattern105 (x3, 
E_V2SImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 892; /* notxorv2si3 */

        case E_V4SImode:
          if (pattern105 (x3, 
E_V4SImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 893; /* notxorv4si3 */

        case E_V1DImode:
          if (pattern105 (x3, 
E_V1DImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 894; /* notxorv1di3 */

        case E_V2DImode:
          if (pattern105 (x3, 
E_V2DImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 895; /* notxorv2di3 */

        case E_V1SFmode:
          if (pattern105 (x3, 
E_V1SFmode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 896; /* notxorv1sf3 */

        case E_V2SFmode:
          if (pattern105 (x3, 
E_V2SFmode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 897; /* notxorv2sf3 */

        case E_V4SFmode:
          if (pattern105 (x3, 
E_V4SFmode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 898; /* notxorv4sf3 */

        case E_V1DFmode:
          if (pattern105 (x3, 
E_V1DFmode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 899; /* notxorv1df3 */

        case E_V2DFmode:
          if (pattern105 (x3, 
E_V2DFmode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 900; /* notxorv2df3 */

        case E_V1TFmode:
          if (pattern105 (x3, 
E_V1TFmode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 901; /* notxorv1tf3 */

        case E_V1TImode:
          if (pattern105 (x3, 
E_V1TImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 902; /* notxorv1ti3 */

        case E_TImode:
          if (pattern105 (x3, 
E_TImode) != 0
              || !
#line 1306 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 903; /* notxorti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern105 (x3, 
E_DImode) != 0
              || !(
#line 9059 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2414; /* *nxordi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern105 (x3, 
E_SImode) != 0
              || !
#line 9059 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2415; /* *nxorsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 904; /* one_cmplv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 905; /* one_cmplv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 906; /* one_cmplv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 907; /* one_cmplv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 908; /* one_cmplv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 909; /* one_cmplv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 910; /* one_cmplv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 911; /* one_cmplv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 912; /* one_cmplv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 913; /* one_cmplv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 914; /* one_cmplv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 915; /* one_cmplv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 916; /* one_cmplv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 917; /* one_cmplv2di2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 918; /* one_cmplv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 919; /* one_cmplv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 920; /* one_cmplv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 921; /* one_cmplv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 922; /* one_cmplv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 923; /* one_cmplv1tf2 */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 924; /* one_cmplv1ti2 */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 1314 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 925; /* one_cmplti2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8654 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2397; /* *notdi */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8654 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2398; /* *notsi */

        default:
          return -1;
        }

    case UNGE:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern106 (x3, 
E_V1SFmode, 
E_V1SImode) != 0
              || !(
#line 2232 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1355; /* vec_cmpgtv1sf_quiet_nocc */

        case E_V2SImode:
          if (pattern106 (x3, 
E_V2SFmode, 
E_V2SImode) != 0
              || !(
#line 2232 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1356; /* vec_cmpgtv2sf_quiet_nocc */

        case E_V4SImode:
          if (pattern106 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 2232 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1357; /* vec_cmpgtv4sf_quiet_nocc */

        case E_V1DImode:
          if (pattern106 (x3, 
E_V1DFmode, 
E_V1DImode) != 0
              || !
#line 2232 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1358; /* vec_cmpgtv1df_quiet_nocc */

        case E_V2DImode:
          if (pattern106 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 2232 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1359; /* vec_cmpgtv2df_quiet_nocc */

        case E_V1TImode:
          if (pattern106 (x3, 
E_V1TFmode, 
E_V1TImode) != 0
              || !(
#line 2232 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1360; /* vec_cmpgtv1tf_quiet_nocc */

        case E_TImode:
          if (pattern106 (x3, 
E_TFmode, 
E_TImode) != 0
              || !(
#line 2232 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1361; /* vec_cmpgttf_quiet_nocc */

        default:
          return -1;
        }

    case UNLT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern107 (x3, 
E_V1SFmode, 
E_V1SImode) != 0
              || !(
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1362; /* vec_cmpgev1sf_quiet_nocc */

        case E_V2SImode:
          if (pattern107 (x3, 
E_V2SFmode, 
E_V2SImode) != 0
              || !(
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1363; /* vec_cmpgev2sf_quiet_nocc */

        case E_V4SImode:
          if (pattern107 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1364; /* vec_cmpgev4sf_quiet_nocc */

        case E_V1DImode:
          if (pattern107 (x3, 
E_V1DFmode, 
E_V1DImode) != 0
              || !
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1365; /* vec_cmpgev1df_quiet_nocc */

        case E_V2DImode:
          if (pattern107 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1366; /* vec_cmpgev2df_quiet_nocc */

        case E_V1TImode:
          if (pattern107 (x3, 
E_V1TFmode, 
E_V1TImode) != 0
              || !(
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1367; /* vec_cmpgev1tf_quiet_nocc */

        case E_TImode:
          if (pattern107 (x3, 
E_TFmode, 
E_TImode) != 0
              || !(
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1368; /* vec_cmpgetf_quiet_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || pattern140 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0
              || !
#line 2810 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1523; /* *vec_extendv4sf */

        case 1:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern140 (x3, 
E_V2DFmode, 
E_V1DFmode, 
E_V1TFmode) != 0
              || !
#line 2854 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1524; /* *vec_extendv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 3177 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return 1558; /* extenddftf2_vr */
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 5781 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || TFmode != DFmode || DFmode != SFmode)) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2096; /* *extenddftf2 */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 5781 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || TFmode != DFmode || SFmode != SFmode)) && 
#line 755 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2100; /* *extendsftf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if (
#line 5769 "../../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
                return 2095; /* *extendsfdf2_z13 */
              if (!
#line 5781 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || DFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2102; /* *extendsfdf2 */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 5781 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || DFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2098; /* *extenddfdf2 */

            default:
              return -1;
            }

        case E_FPRX2mode:
          switch (pattern87 (x3, 
E_FPRX2mode))
            {
            case 0:
              if (!(
#line 5781 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || DFmode != SFmode)) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2097; /* *extenddffprx22 */

            case 1:
              if (!(
#line 5781 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || SFmode != SFmode)) && 
#line 755 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2101; /* *extendsffprx22 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern87 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5781 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || SFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2099; /* *extenddfsf2 */

            case 1:
              if (!
#line 5781 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || SFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2103; /* *extendsfsf2 */

            default:
              return -1;
            }

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5803 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2104; /* extendddtd2 */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_SDmode)
              || !
#line 5811 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2105; /* extendsddd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_CCVEQmode:
          x6 = XEXP (x4, 1);
          if (GET_MODE (x6) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[2], E_V16QImode)
                  || !
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !scratch_operand (operands[2], E_V8HImode)
                  || !
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          x6 = XEXP (x4, 1);
          switch (pattern235 (x6, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          x6 = XEXP (x4, 1);
          switch (pattern235 (x6, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case EQ:
          if (pattern236 (x1, 
E_CCVEQmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern273 (x7, 
E_V16QImode) != 0
                  || !
#line 2030 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 431; /* *vec_cmpeqv16qi_cc */

            case E_V8HImode:
              if (pattern273 (x7, 
E_V8HImode) != 0
                  || !
#line 2030 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 432; /* *vec_cmpeqv8hi_cc */

            case E_V4SImode:
              if (pattern273 (x7, 
E_V4SImode) != 0
                  || !
#line 2030 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 433; /* *vec_cmpeqv4si_cc */

            case E_V2DImode:
              if (pattern273 (x7, 
E_V2DImode) != 0
                  || !
#line 2030 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 434; /* *vec_cmpeqv2di_cc */

            case E_V1TImode:
              if (pattern273 (x7, 
E_V1TImode) != 0
                  || !(
#line 2030 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 435; /* *vec_cmpeqv1ti_cc */

            case E_TImode:
              if (pattern273 (x7, 
E_TImode) != 0
                  || !(
#line 2030 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 436; /* *vec_cmpeqti_cc */

            case E_V4SFmode:
              if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2113 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 461; /* *vec_cmpeqv4sf_cc */

            case E_V2DFmode:
              if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2113 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 462; /* *vec_cmpeqv2df_cc */

            case E_V1TFmode:
              if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2113 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 463; /* *vec_cmpeqv1tf_cc */

            case E_TFmode:
              if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2113 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 464; /* *vec_cmpeqtf_cc */

            default:
              return -1;
            }

        case GT:
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_CCVIHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVIHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern273 (x7, 
E_V16QImode) != 0
                      || !
#line 2040 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 437; /* *vec_cmphv16qi_cc */

                case E_V8HImode:
                  if (pattern273 (x7, 
E_V8HImode) != 0
                      || !
#line 2040 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 438; /* *vec_cmphv8hi_cc */

                case E_V4SImode:
                  if (pattern273 (x7, 
E_V4SImode) != 0
                      || !
#line 2040 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 439; /* *vec_cmphv4si_cc */

                case E_V2DImode:
                  if (pattern273 (x7, 
E_V2DImode) != 0
                      || !
#line 2040 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 440; /* *vec_cmphv2di_cc */

                case E_V1TImode:
                  if (pattern273 (x7, 
E_V1TImode) != 0
                      || !(
#line 2040 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 441; /* *vec_cmphv1ti_cc */

                case E_TImode:
                  if (pattern273 (x7, 
E_TImode) != 0
                      || !(
#line 2040 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 442; /* *vec_cmphti_cc */

                default:
                  return -1;
                }

            case E_CCVFHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVFHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !(
#line 2124 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 465; /* *vec_cmphv4sf_cc */

                case E_V2DFmode:
                  if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !
#line 2124 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 466; /* *vec_cmphv2df_cc */

                case E_V1TFmode:
                  if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                      || !(
#line 2124 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 467; /* *vec_cmphv1tf_cc */

                case E_TFmode:
                  if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                      || !(
#line 2124 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 468; /* *vec_cmphtf_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GTU:
          if (pattern236 (x1, 
E_CCVIHUmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern273 (x7, 
E_V16QImode) != 0
                  || !
#line 2050 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 443; /* *vec_cmphlv16qi_cc */

            case E_V8HImode:
              if (pattern273 (x7, 
E_V8HImode) != 0
                  || !
#line 2050 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 444; /* *vec_cmphlv8hi_cc */

            case E_V4SImode:
              if (pattern273 (x7, 
E_V4SImode) != 0
                  || !
#line 2050 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 445; /* *vec_cmphlv4si_cc */

            case E_V2DImode:
              if (pattern273 (x7, 
E_V2DImode) != 0
                  || !
#line 2050 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 446; /* *vec_cmphlv2di_cc */

            case E_V1TImode:
              if (pattern273 (x7, 
E_V1TImode) != 0
                  || !(
#line 2050 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 447; /* *vec_cmphlv1ti_cc */

            case E_TImode:
              if (pattern273 (x7, 
E_TImode) != 0
                  || !(
#line 2050 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 448; /* *vec_cmphlti_cc */

            default:
              return -1;
            }

        case GE:
          if (pattern236 (x1, 
E_CCVFHEmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2135 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 469; /* *vec_cmphev4sf_cc */

            case E_V2DFmode:
              if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2135 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 470; /* *vec_cmphev2df_cc */

            case E_V1TFmode:
              if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2135 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 471; /* *vec_cmphev1tf_cc */

            case E_TFmode:
              if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2135 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 472; /* *vec_cmphetf_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case USE:
      if (!memory_operand (operands[0], E_BLKmode)
          || !memory_operand (operands[1], E_BLKmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1493 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1774; /* *clc */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || pattern98 (x4) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  switch (pattern258 (x1))
    {
    case 0:
      if (!(
#line 3691 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 1888; /* *cpymem_long */

    case 1:
      if (!(
#line 3691 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 1889; /* *cpymem_long */

    case 2:
      if (!
#line 3704 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
        return -1;
      return 1890; /* *cpymem_long_31z */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40;
  int res ATTRIBUTE_UNUSED;
  if (pattern6 (x1, 
39, 
E_TImode, 
17, 
38) != 0
      || pattern298 (x1, 
41, 
E_TImode, 
19, 
40, 
18) != 0
      || pattern299 (x1, 
43, 
E_TImode, 
21, 
42, 
20) != 0
      || pattern300 (x1, 
E_TImode, 
45, 
23, 
44, 
22) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24
      || GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 46
      || GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 25
      || GET_MODE (x7) != E_TImode)
    return -1;
  x8 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 47
      || GET_MODE (x9) != E_TImode)
    return -1;
  x10 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 26
      || GET_MODE (x11) != E_TImode)
    return -1;
  x12 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 48
      || GET_MODE (x13) != E_TImode)
    return -1;
  x14 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 27
      || GET_MODE (x15) != E_TImode)
    return -1;
  x16 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 49
      || GET_MODE (x17) != E_TImode)
    return -1;
  x18 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 28
      || GET_MODE (x19) != E_TImode)
    return -1;
  x20 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 50
      || GET_MODE (x21) != E_TImode)
    return -1;
  x22 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 29
      || GET_MODE (x23) != E_TImode)
    return -1;
  x24 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x24) != CLOBBER)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 51
      || GET_MODE (x25) != E_TImode)
    return -1;
  x26 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x26) != CLOBBER)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 30
      || GET_MODE (x27) != E_TImode)
    return -1;
  x28 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x28) != CLOBBER)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 52
      || GET_MODE (x29) != E_TImode)
    return -1;
  x30 = XVECEXP (x1, 0, 32);
  if (GET_CODE (x30) != CLOBBER)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 31
      || GET_MODE (x31) != E_TImode)
    return -1;
  x32 = XVECEXP (x1, 0, 33);
  if (GET_CODE (x32) != CLOBBER)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 53
      || GET_MODE (x33) != E_TImode)
    return -1;
  x34 = XVECEXP (x1, 0, 0);
  x35 = XEXP (x34, 1);
  x36 = XVECEXP (x35, 0, 0);
  operands[0] = x36;
  if (!const_int_operand (operands[0], E_VOIDmode))
    return -1;
  x37 = XVECEXP (x1, 0, 1);
  x38 = XEXP (x37, 0);
  operands[1] = x38;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x39 = XEXP (x37, 1);
  x40 = XVECEXP (x39, 0, 0);
  if (!rtx_equal_p (x40, operands[0])
      || !
#line 12377 "../../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
    return -1;
  return 2648; /* tbegin_1_z13 */
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return recog_62 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_58 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_57 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_55 (x1, insn, pnum_clobbers);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 33)
        return -1;
      return recog_27 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_68 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_76 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_65 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_71 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1164 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 726; /* udivv4si3 */

        case 1:
          if (!
#line 1164 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 727; /* udivv2di3 */

        case 2:
          if (!
#line 1164 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 728; /* udivv1ti3 */

        case 3:
          if (!
#line 1164 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 729; /* udivti3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1173 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 730; /* modv4si3 */

        case 1:
          if (!
#line 1173 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 731; /* modv2di3 */

        case 2:
          if (!
#line 1173 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 732; /* modv1ti3 */

        case 3:
          if (!
#line 1173 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 733; /* modti3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1182 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 734; /* umodv4si3 */

        case 1:
          if (!
#line 1182 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 735; /* umodv2di3 */

        case 2:
          if (!
#line 1182 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 736; /* umodv1ti3 */

        case 3:
          if (!
#line 1182 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 737; /* umodti3 */

        default:
          return -1;
        }

    case NEG:
      return recog_56 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_59 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_60 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 931; /* clzv1qi2 */

        case 1:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 932; /* clzv2qi2 */

        case 2:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 933; /* clzv4qi2 */

        case 3:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 934; /* clzv8qi2 */

        case 4:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 935; /* clzv16qi2 */

        case 5:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 936; /* clzv1hi2 */

        case 6:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 937; /* clzv2hi2 */

        case 7:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 938; /* clzv4hi2 */

        case 8:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 939; /* clzv8hi2 */

        case 9:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 940; /* clzv1si2 */

        case 10:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 941; /* clzv2si2 */

        case 11:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 942; /* clzv4si2 */

        case 12:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 943; /* clzv1di2 */

        case 13:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 944; /* clzv2di2 */

        case 14:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 945; /* clzv1sf2 */

        case 15:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 946; /* clzv2sf2 */

        case 16:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 947; /* clzv4sf2 */

        case 17:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 948; /* clzv1df2 */

        case 18:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 949; /* clzv2df2 */

        case 19:
          if (!
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 950; /* clzv1tf2 */

        case 20:
          if (!(
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 951; /* clzv1ti2 */

        case 21:
          if (!(
#line 1436 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 952; /* clzti2 */

        case 22:
          if (!
#line 9604 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
            return -1;
          return 2499; /* *clzg */

        default:
          return -1;
        }

    case CTZ:
      return recog_78 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_66 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_63 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_61 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_64 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1107; /* *sminv1qi3 */

        case 1:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1108; /* *sminv2qi3 */

        case 2:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1109; /* *sminv4qi3 */

        case 3:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1110; /* *sminv8qi3 */

        case 4:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1111; /* *sminv16qi3 */

        case 5:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1112; /* *sminv1hi3 */

        case 6:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1113; /* *sminv2hi3 */

        case 7:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1114; /* *sminv4hi3 */

        case 8:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1115; /* *sminv8hi3 */

        case 9:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1116; /* *sminv1si3 */

        case 10:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1117; /* *sminv2si3 */

        case 11:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1118; /* *sminv4si3 */

        case 12:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1119; /* *sminv1di3 */

        case 13:
          if (!
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1120; /* *sminv2di3 */

        case 14:
          if (!(
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1121; /* *sminv1ti3 */

        case 15:
          if (!(
#line 1632 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1122; /* *sminti3 */

        case 16:
          if (!
#line 2051 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1289; /* *sminv4sf3_vxe */

        case 17:
          if (
#line 2051 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1290; /* *sminv2df3_vxe */
          if (!
#line 2060 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1293; /* *sminv2df3_vx */

        case 18:
          if (!
#line 2051 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1291; /* *sminv1tf3_vxe */

        case 19:
          if (!
#line 2051 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1292; /* *smintf3_vxe */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1123; /* *smaxv1qi3 */

        case 1:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1124; /* *smaxv2qi3 */

        case 2:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1125; /* *smaxv4qi3 */

        case 3:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1126; /* *smaxv8qi3 */

        case 4:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1127; /* *smaxv16qi3 */

        case 5:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1128; /* *smaxv1hi3 */

        case 6:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1129; /* *smaxv2hi3 */

        case 7:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1130; /* *smaxv4hi3 */

        case 8:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1131; /* *smaxv8hi3 */

        case 9:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1132; /* *smaxv1si3 */

        case 10:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1133; /* *smaxv2si3 */

        case 11:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1134; /* *smaxv4si3 */

        case 12:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1135; /* *smaxv1di3 */

        case 13:
          if (!
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1136; /* *smaxv2di3 */

        case 14:
          if (!(
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1137; /* *smaxv1ti3 */

        case 15:
          if (!(
#line 1657 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1138; /* *smaxti3 */

        case 16:
          if (!
#line 2015 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1284; /* *smaxv4sf3_vxe */

        case 17:
          if (
#line 2015 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1285; /* *smaxv2df3_vxe */
          if (!
#line 2024 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1288; /* *smaxv2df3_vx */

        case 18:
          if (!
#line 2015 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1286; /* *smaxv1tf3_vxe */

        case 19:
          if (!
#line 2015 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1287; /* *smaxtf3_vxe */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1139; /* *uminv1qi3 */

        case 1:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1140; /* *uminv2qi3 */

        case 2:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1141; /* *uminv4qi3 */

        case 3:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1142; /* *uminv8qi3 */

        case 4:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1143; /* *uminv16qi3 */

        case 5:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1144; /* *uminv1hi3 */

        case 6:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1145; /* *uminv2hi3 */

        case 7:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1146; /* *uminv4hi3 */

        case 8:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1147; /* *uminv8hi3 */

        case 9:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1148; /* *uminv1si3 */

        case 10:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1149; /* *uminv2si3 */

        case 11:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1150; /* *uminv4si3 */

        case 12:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1151; /* *uminv1di3 */

        case 13:
          if (!
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1152; /* *uminv2di3 */

        case 14:
          if (!(
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1153; /* *uminv1ti3 */

        case 15:
          if (!(
#line 1682 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1154; /* *uminti3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1155; /* *umaxv1qi3 */

        case 1:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1156; /* *umaxv2qi3 */

        case 2:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1157; /* *umaxv4qi3 */

        case 3:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1158; /* *umaxv8qi3 */

        case 4:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1159; /* *umaxv16qi3 */

        case 5:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1160; /* *umaxv1hi3 */

        case 6:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1161; /* *umaxv2hi3 */

        case 7:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1162; /* *umaxv4hi3 */

        case 8:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1163; /* *umaxv8hi3 */

        case 9:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1164; /* *umaxv1si3 */

        case 10:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1165; /* *umaxv2si3 */

        case 11:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1166; /* *umaxv4si3 */

        case 12:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1167; /* *umaxv1di3 */

        case 13:
          if (!
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1168; /* *umaxv2di3 */

        case 14:
          if (!(
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1169; /* *umaxv1ti3 */

        case 15:
          if (!(
#line 1707 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1170; /* *umaxti3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_72 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_75 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_77 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_69 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_74 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_70 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 3002 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1529; /* fix_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3002 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1530; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 3034 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1531; /* fixuns_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3034 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1532; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      operands[3] = x4;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || XWINT (x4, 0) != 0L)
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!(
#line 4408 "../../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1946; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4408 "../../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1947; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1948; /* *pre_z10_extvdi */

        case 1:
          *pnum_clobbers = 1;
          return 1949; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 5694 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2090; /* truncdfsf2 */

            case E_TFmode:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[1], E_TFmode)
                  || !
#line 5712 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2092; /* trunctfsf2_fpr */

            default:
              return -1;
            }

        case E_DFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 5712 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2091; /* trunctfdf2_fpr */

        case E_SDmode:
          if (!register_operand (operands[0], E_SDmode)
              || GET_MODE (x2) != E_SDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5743 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2094; /* truncddsd2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_67 (x1, insn, pnum_clobbers);

    case CALL:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x2, 1);
      if (!const_int_operand (x6, E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 1)
            return -1;
          operands[1] = x6;
          if (!
#line 10798 "../../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (XEXP (PATTERN (insn), 1), 0), 0)) == Pmode))
            return -1;
          return 2564; /* *sibcall_value_br */

        case CONST:
        case SYMBOL_REF:
          operands[1] = x7;
          if (!bras_sym_operand (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x6;
          if (
#line 10828 "../../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2565; /* *sibcall_value_brc */
          if (!
#line 10837 "../../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2566; /* *sibcall_value_brcl */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_73 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12103 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      *pnum_clobbers = 1;
      return 2636; /* *popcountdi_z15 */

    case COPYSIGN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (pattern0 (x2, 
E_TFmode) != 0
              || !(
#line 12270 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2641; /* copysigntf3_fpr */

        case E_FPRX2mode:
          if (pattern0 (x2, 
E_FPRX2mode) != 0
              || !(
#line 12270 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2642; /* copysignfprx23 */

        case E_DFmode:
          if (pattern0 (x2, 
E_DFmode) != 0
              || !
#line 12270 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2643; /* copysigndf3 */

        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) != 0
              || !
#line 12270 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2644; /* copysignsf3 */

        case E_TDmode:
          if (pattern0 (x2, 
E_TDmode) != 0
              || !(
#line 12270 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2645; /* copysigntd3 */

        case E_DDmode:
          if (pattern0 (x2, 
E_DDmode) != 0
              || !(
#line 12270 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2646; /* copysigndd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
